// SIPAST_CommonDlgs.inc
// Description: Dialogs and Simulation menu for up to 4 Transducer and Function Blocks
// $Revision: 1.2 $
// $Date: Jun  18 2004 $


#define EXTRA_ITEMS_VIEW_MENU_SPECIALIST_COMMON_DLGS	OnlineWindow_yt_1, OnlineWindow_diagnosis, relay_test /*, Menu_S_alarm */
#define EXTRA_ITEMS_VIEW_MENU_MAINTENANCE_COMMON_DLGS	OnlineWindow_diagnosis /*, Menu_M_alarm */
#define EXTRA_ITEMS_DEVICE_MENU_SPECIALIST_COMMON_DLGS Menu_reset, Offline_Dialog_Menu_device_parametrierung_s, Menu_simulation


// --- Diagnosis Dialog -------------------------------------------------------

MENU OnlineWindow_diagnosis
{
	LABEL		[menu_dialog_diagnosis];
	ITEMS
	{
		Page_diagnosis_overview,
		Page_diagnosis_general,
		Page_diagnosis_general2,
		Page_diagnosis_features,
		Page_diagnosis_phys_block,
		Page_diagnosis_trans1,

#ifdef TRANS2_AVAILABLE
		Page_diagnosis_trans2,
#endif

#ifdef TRANS3_AVAILABLE
		Page_diagnosis_trans3,
#endif

#ifdef TRANS4_AVAILABLE
		Page_diagnosis_trans4,
#endif


#ifdef FUNC1_AVAILABLE
		Page_diagnosis_func1,
#endif

#ifdef FUNC2_AVAILABLE
		Page_diagnosis_func2,
#endif

#ifdef FUNC3_AVAILABLE
		Page_diagnosis_func3,
#endif

#ifdef FUNC4_AVAILABLE
		Page_diagnosis_func4,
#endif
	}
}

MENU Page_diagnosis_general2
{
	LABEL		[menu_dialog_general2];
	ITEMS
	{
		phys_diagnosis,
		phys_diagnosis_extension_byte0,
		phys_diagnosis_extension_byte1,
		phys_diagnosis_extension_byte2,
		phys_diagnosis_extension_byte3
	}
}

MENU Page_diagnosis_features
{
	LABEL		[menu_diagnosis_features];
	ITEMS
	{
		phys_feature_supported,
		phys_feature_enabled
	}
}

MENU Page_diagnosis_overview
{
	LABEL	[menu_dialog_overview];
	ITEMS
	{
		trans1.actual_mode,

#ifdef TRANS2_AVAILABLE
		trans2.actual_mode,
#endif

#ifdef TRANS3_AVAILABLE
		trans3.actual_mode,
#endif

		func1.actual_mode,

#ifdef FUNC2_AVAILABLE
		func2.actual_mode
#endif

#ifdef FUNC3_AVAILABLE
		func3.actual_mode
#endif

#ifdef FUNC4_AVAILABLE
		func4.actual_mode
#endif


	}
}


// --- Alarm Menu -------------------------------------------------------------

MENU Menu_S_alarm
{
	LABEL		[menu_dialog_alarm];
	ITEMS
	{
#ifdef FUNC1_AVAILABLE
		OnlineWindow_S_alarm_func1,
#endif

#ifdef FUNC2_AVAILABLE
		OnlineWindow_S_alarm_func2,
#endif

#ifdef FUNC3_AVAILABLE
		OnlineWindow_S_alarm_func3,
#endif

#ifdef FUNC4_AVAILABLE
		OnlineWindow_S_alarm_func4,
#endif
	}
}



MENU Menu_M_alarm
{
	LABEL		[menu_dialog_alarm];
	ITEMS
	{
#ifdef FUNC1_AVAILABLE
		OnlineWindow_M_alarm_func1,
#endif

#ifdef FUNC2_AVAILABLE
		OnlineWindow_M_alarm_func2,
#endif

#ifdef FUNC3_AVAILABLE
		OnlineWindow_M_alarm_func3,
#endif

#ifdef FUNC4_AVAILABLE
		OnlineWindow_M_alarm_func4,
#endif
	}
}



// --- Simulation Menu --------------------------------------------------------

MENU Menu_simulation
{
	LABEL		[menu_dialog_simulation];
	ITEMS
	{
#ifdef FUNC1_SIMULATION_AVAILABLE
		OnlineDialog_simulation_func1,
#endif

#ifdef FUNC2_SIMULATION_AVAILABLE
		OnlineDialog_simulation_func2,
#endif

#ifdef FUNC3_SIMULATION_AVAILABLE
		OnlineDialog_simulation_func3,
#endif

#ifdef FUNC4_SIMULATION_AVAILABLE
		OnlineDialog_simulation_func4,
#endif
    diagnose_
//    ,
//    relay_test
	}
}

MENU diagnose_
{
	LABEL		"diag_ext_test";

	ITEMS
	{
		auto_ext_diag,
		method_write_auto_ext_diag
	}
}

METHOD method_write_auto_ext_diag 
{
	LABEL		"Set_auto_ext_diag";
	DEFINITION
	{
		WriteCommand (write_auto_ext_diag);
	}
}

VARIABLE auto_ext_diag
{
	LABEL		"Ext_Diag_Var";
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1);
	HANDLING	WRITE;
}


COMMAND write_auto_ext_diag
{
	BLOCK physical_block;
	INDEX 35;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			auto_ext_diag
		}
		REPLY
		{
		}
	}
}

MENU relay_test
{
	LABEL		"relay_test";
//  ACCESS OFFLINE;
	ITEMS
	{
		auto_muf_relay,
		method_write_auto_muf_relay
	}
}
METHOD method_write_auto_muf_relay 
{
	LABEL		"Set_auto_muf_relay";
	DEFINITION
	{
		WriteCommand (write_auto_muf_relay);
	}
}

VARIABLE auto_muf_relay
{
	LABEL		"Ext_muf_Var";
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1);
	HANDLING	WRITE;
}

COMMAND write_auto_muf_relay
{
	BLOCK physical_block;
	INDEX 36;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			auto_muf_relay
		}
		REPLY
		{
		}
	}
}