/*===================================================================
 File name:	    T_6680_0A8A.ddl
 Date:      	  Aug. 21. 2006
---------------------------------------------------------------------
 DESCRIPTION:
 EDD Main file
                                      
 DEVICE:
 T6680 Humidity Device 
---------------------------------------------------------------------
 Revision history:
 REV 0.01 DATE:210806	 TMG/WZ first release
 REV 0.02 DATE:141207 Change: Umstrukturierung der Mens zur Online-Problemlsung
 

===================================================================*/



MANUFACTURER	322, // bis PDM 6.02;
//MANUFACTURER 322, /Firmenname:testo AG,DEVICE_MAN_ID: DECIMAL 322, HEX 142 ab PDM 6.02 HF1
DEVICE_TYPE		1,
DEVICE_REVISION 	0x0300,
DD_REVISION		1



#define DEVICE_TITLE [Testo6680]




// Physical Block --------------------------------------------------------------

#include "T_6680_0A8A_PB.inc"



// Transducer Block 1: Temperature ---------------------------------------------

#include "T_6680_trans1_temp_0A8A.inc"



// Transducer Block 2: Testo specific and Humidity -----------------------------

#include "T_6680_trans2_hm_0A8A.inc"



// Function Block 1: Analog Input ----------------------------------------------

#include "T_6680_0A8A_AI1.inc"



// Function Block 2: Analog Input ----------------------------------------------

#include "T_6680_0A8A_AI2.inc"

#include "T_6680_0A8A_menu.inc"

// Common dialogs and menus ----------------------------------------------------

MENU OnlineWindow_display
{
	LABEL		[menu_dialog_display];
	ITEMS
	{
		Page_display_func1,
		Page_display_trans1,
		Page_display_func2,
		Page_display_trans2
	}
}

#define EXTRA_ITEMS_VIEW_MENU_SPECIALIST_COMMON_DLGS	OnlineWindow_yt_1, OnlineWindow_diagnosis, relay_test /*, Menu_S_alarm */
#define EXTRA_ITEMS_VIEW_MENU_MAINTENANCE_COMMON_DLGS	OnlineWindow_diagnosis /*, Menu_M_alarm */
#define EXTRA_ITEMS_DEVICE_MENU_SPECIALIST_COMMON_DLGS Menu_reset, Offline_Dialog_Menu_device_parametrierung_s, Menu_simulation
// --- Diagnosis Dialog -------------------------------------------------------

MENU OnlineWindow_diagnosis
{
	LABEL		[menu_dialog_diagnosis];
	ITEMS
	{
		Page_diagnosis_overview,
		Page_diagnosis_general,
		Page_diagnosis_general2,
		Page_diagnosis_features,
		Page_diagnosis_phys_block,
		Page_diagnosis_trans1,

#ifdef TRANS2_AVAILABLE
		Page_diagnosis_trans2,
#endif

#ifdef TRANS3_AVAILABLE
		Page_diagnosis_trans3,
#endif

#ifdef TRANS4_AVAILABLE
		Page_diagnosis_trans4,
#endif


#ifdef FUNC1_AVAILABLE
		Page_diagnosis_func1,
#endif

#ifdef FUNC2_AVAILABLE
		Page_diagnosis_func2,
#endif

#ifdef FUNC3_AVAILABLE
		Page_diagnosis_func3,
#endif

#ifdef FUNC4_AVAILABLE
		Page_diagnosis_func4,
#endif
	}
}

MENU Page_diagnosis_general2
{
	LABEL		[menu_dialog_general2];
	ITEMS
	{
		phys_diagnosis,
		phys_diagnosis_extension_byte0,
		phys_diagnosis_extension_byte1,
		phys_diagnosis_extension_byte2,
		phys_diagnosis_extension_byte3
	}
}

MENU Page_diagnosis_features
{
	LABEL		[menu_diagnosis_features];
	ITEMS
	{
		phys_feature_supported,
		phys_feature_enabled
	}
}

MENU Page_diagnosis_overview
{
	LABEL	[menu_dialog_overview];
	ITEMS
	{
		trans1.actual_mode,

#ifdef TRANS2_AVAILABLE
		trans2.actual_mode,
#endif

#ifdef TRANS3_AVAILABLE
		trans3.actual_mode,
#endif

		func1.actual_mode,

#ifdef FUNC2_AVAILABLE
		func2.actual_mode
#endif

#ifdef FUNC3_AVAILABLE
		func3.actual_mode
#endif

#ifdef FUNC4_AVAILABLE
		func4.actual_mode
#endif


	}
}
// --- Simulation Menu --------------------------------------------------------

MENU Menu_simulation
{
	LABEL		[menu_dialog_simulation];
	ITEMS
	{
#ifdef FUNC1_SIMULATION_AVAILABLE
		OnlineDialog_simulation_func1,
#endif

#ifdef FUNC2_SIMULATION_AVAILABLE
		OnlineDialog_simulation_func2,
#endif

#ifdef FUNC3_SIMULATION_AVAILABLE
		OnlineDialog_simulation_func3,
#endif

#ifdef FUNC4_SIMULATION_AVAILABLE
		OnlineDialog_simulation_func4,
#endif
	}
}

// --- Trend Menu -------------------------------------------------------- 
#define YT1_LABEL		[Messkanal_1]
#define YT1_VALUE		func1_AI_out_value
#define	YT1_LRV		func1_AI_out_lower_range_value
#define YT1_URV		func1_AI_out_upper_range_value
#include "SI_YT.inc"

#define YT11_LABEL		[Messkanal_2]
#define YT11_VALUE		func2_AI_out_value
#define	YT11_LRV		func2_AI_out_lower_range_value
#define YT11_URV		func2_AI_out_upper_range_value
#include "SI_YT_1.inc"



//#include "SIPAST_CommParamsDlg.inc"


#include "SI_FileM.inc"
#include "SI_DevM.inc"
#include "SI_ViewM.inc"
// #include "SI_OptM.inc"
#include "SI_HlpM.inc"

#include "T_6680_0A8A_IM.inc"

MENU Menu_Main_Specialist
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_File,
		Menu_S_Device,
		Menu_S_View,
		Menu_Options,
		Menu_Help
	}
}

MENU Menu_Main_Maintenance
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_File,
		Menu_M_Device,
		Menu_M_View,
		Menu_M_Options,
		Menu_Help
	}
}


MENU Menu_Options
{
	LABEL		[menu_Options];
	ITEMS
	{
			std_Einstellungen,
			std_Untereintraege

#ifdef COMM_ERROR_DIALOG_AVAILABLE
			,SEPARATOR,
			OfflineDialog_CommErrorHandling
#endif
#ifdef COMMUNICATION_PARAM_DLG_AVAILABLE
			,OfflineDialog_Communication_Params
#endif
	}
}

MENU Menu_M_Options
{
	LABEL		[menu_Options];
	ITEMS
	{
			std_Einstellungen,
			std_Untereintraege
	}
}




METHOD std_Einstellungen
{
	LABEL		[menu_Options_Properties];
	DEFINITION
	{
	}
}

METHOD std_Untereintraege
{
	LABEL		[menu_Options_Subitems];
	DEFINITION
	{
	}
}

// --- Parameter table --------------------------------------------------------

MENU Table_Main_Specialist
{
	LABEL	DEVICE_TITLE ;
	ITEMS
	{
		Tab_s_ident,
		Tab_s_input,
//		Tab_s_Channel_1
//		Tab_s_Channel_2
		Tab_s_output,
		Tab_s_opconds,
		Tab_s_const,
		Tab_s_interface_set,
		Tab_s_certificates
	}
}

MENU Table_Main_Maintenance
{
	LABEL	DEVICE_TITLE ;
	ITEMS
	{
		Tab_m_ident,
		Tab_m_input,
		Tab_m_output,
		Tab_s_opconds,
		Tab_s_const,
		Tab_s_interface_set,
		Tab_s_certificates
	}
}


MENU Tab_s_input
{
	LABEL		[menu_input];
	ITEMS
	{
		Tab_s_trans1,
		Tab_s_trans2
	}
}

MENU Tab_m_input
{
	LABEL		[menu_input];
	ITEMS
	{
		Tab_m_trans1,
		Tab_m_trans2
	}
}

MENU Tab_s_output
{
	LABEL		[menu_output];
	ITEMS
	{
		Tab_s_Channel_1,
		Tab_s_Channel_2
	}
}

#define KANALANZEIGE1 \
	SELECT (Channel_1) \
	{ \
		CASE 8: [Temperature]; \
		CASE 0: [Relative_Humidity]; \
		CASE 1:	[Dew_Point]; \
		CASE 2:	[Absolute_Humidity]; \
		CASE 3:	[Specific_Humidity]; \
		CASE 4:	[Enthalpie]; \
		CASE 5:	[Psychrometertemperature]; \
		CASE 6:	[Vapour_partial_pressure]; \
		CASE 7:	[Water_Content]; \
	} 
	
#define KANALANZEIGE2 \
	SELECT (Channel_2) \
	{ \
		CASE 8: [Temperature]; \
		CASE 0: [Relative_Humidity]; \
		CASE 1:	[Dew_Point]; \
		CASE 2:	[Absolute_Humidity]; \
		CASE 3:	[Specific_Humidity]; \
		CASE 4:	[Enthalpie]; \
		CASE 5:	[Psychrometertemperature]; \
		CASE 6:	[Vapour_partial_pressure]; \
		CASE 7:	[Water_Content]; \
	} 

MENU Tab_s_Channel_1
{
	LABEL		KANALANZEIGE1;
	ITEMS
	{
		Tab_s_func1
	}
}

MENU Tab_s_Channel_2
{
	LABEL		KANALANZEIGE2;
	ITEMS
	{
		Tab_s_func2
	}
}


MENU Tab_m_output
{
	LABEL		[menu_output];
	ITEMS
	{
		Tab_m_Channel_1,
		Tab_m_Channel_2
	}
}

MENU Tab_m_Channel_1
{
	LABEL		KANALANZEIGE1;
	ITEMS
	{
		Tab_m_func1
	}
}

MENU Tab_m_Channel_2
{
	LABEL		KANALANZEIGE2;
	ITEMS
	{
		Tab_m_func2
	}
}


MENU download_variables
{
	LABEL		[menu_load_to_PC];
	PRE_READ_ACTIONS
	{

		DEFINITION
		{
#ifdef _V602_		
			IM_INDEX = 65000;
			WriteCommand(commandPRE_READ_IM);
			ReadCommand(commandREAD_IM0);
#endif				
			ReadCommand (read_func1_AI_channel);
      ReadCommand (read_func2_AI_channel);
      ReadCommand (read_trans2_hm_primary_value_type);
      ReadCommand (read_trans2_hm_secondary_value_type_1);
      ReadCommand (read_func1_AI_out_scale);
      ReadCommand (read_func2_AI_out_scale);
		}
	
		method_refresh_device_configuration_settings
	}
	ITEMS
	{
		PHYS_LOAD_TO_PC,
		TRANS1_LOAD_TO_PC,
		TRANS2_LOAD_TO_PC,
		FUNC1_LOAD_TO_PC,
		FUNC2_LOAD_TO_PC,
#ifdef _V602_		
		MANUFACTURER_SPECIFIC_IM0,
        MANUFACTURER_ID,
        ORDER_ID,
        SERIAL_NUMBER,
        HARDWARE_REVISION,
        SOFTWARE_REVISION_0,
        SOFTWARE_REVISION_1,
        SOFTWARE_REVISION_2,
        SOFTWARE_REVISION_3,
        REV_COUNTER,
		PROFILE_ID_HIBYTE,
		PROFILE_ID_LOBYTE,
        PROFILE_SPECIFIC_TYPE,
        IM_VERSION,
        IM_SUPPORTED
        ,

		IF( (IM_SUPPORTED & 0x002) == 0x002 )
		{
			MANUFACTURER_SPECIFIC_IM1,
			TAG_FUNCTION,
			TAG_LOCATION,
		}

		IF( (IM_SUPPORTED & 0x004) == 0x004 )
		{
			MANUFACTURER_SPECIFIC_IM2,
			INSTALLATION_DATE,
		}

		IF( (IM_SUPPORTED & 0x008) == 0x008 )
		{
			MANUFACTURER_SPECIFIC_IM3,
			DESCRIPTOR,
		}

		IF( (IM_SUPPORTED & 0x010) == 0x010 )
		{
			MANUFACTURER_SPECIFIC_IM4,
			SIGNATUR
		}
#endif		
	}
}



MENU upload_variables
{
	LABEL		[menu_load_to_device];

//#ifdef _V602_
//	PRE_WRITE_ACTIONS
//	{
//		DEFINITION
//		{
//			IM_INDEX = 65000;
//			WriteCommand(commandPRE_READ_IM);
//			ReadCommand(commandREAD_IM0);
//		}
//	}
//#endif	
	ITEMS
	{
		PHYS_LOAD_TO_DEVICE,
		TRANS1_LOAD_TO_DEVICE,
		TRANS2_LOAD_TO_DEVICE,
		FUNC1_LOAD_TO_DEVICE,
		FUNC2_LOAD_TO_DEVICE,
//#ifdef _V602_		
//		IF( (IM_SUPPORTED & 0x002) == 0x002 )
//		{
//			MANUFACTURER_SPECIFIC_IM1,
//			TAG_FUNCTION,
//			TAG_LOCATION,
//		}
//
//		IF( (IM_SUPPORTED & 0x004) == 0x004 )
//		{
//			MANUFACTURER_SPECIFIC_IM2,
//			INSTALLATION_DATE,
//		}
//
//		IF( (IM_SUPPORTED & 0x008) == 0x008 )
//		{
//			MANUFACTURER_SPECIFIC_IM3,
//			DESCRIPTOR,
//		}
//
//		IF( (IM_SUPPORTED & 0x010) == 0x010 )
//		{
//			MANUFACTURER_SPECIFIC_IM4,
//			SIGNATUR
//		}
//#endif		
	}
}



METHOD method_phys_factory_reset_params
{
	LABEL		[factory_reset_PARAMS];
	DEFINITION
	{
		int status;

		ACKNOWLEDGE([factory_reset_PARAMS]);

		phys_factory_reset = 1; //	[factory_reset_PARAMS]

		status = WriteCommand (write_phys_factory_reset);
	}
}

/*****************************************************
Testo-Gerte Konfiguration
*****************************************************/


MENU Menu_reset
{
	LABEL		[master_reset];
	ITEMS
	{
    OnlineDialog_reset
	}
}
