/*===================================================================
 File name:	    T_6680_0A8A_AI1.inc
 Date:      	  Aug. 21. 2006
---------------------------------------------------------------------
 DESCRIPTION:
 Function Block 1: Analog Input
                                      
 DEVICE:
 T6680 Humidity Device 
---------------------------------------------------------------------
 Revision history:
 REV 0.01 DATE:210806	 TMG/WZ first release

===================================================================*/



// --- macros ---------------------------------------------------

#ifndef FLOAT_MIN
#define	FLOAT_MIN	-3.4E+38
#define	FLOAT_MAX	 3.4E+38
#endif


/**************************************************/
/******************* Configuration ****************/
/**************************************************/

#define FUNC1_AVAILABLE
#define FUNC1_SIMULATION_AVAILABLE

#ifndef FUNC1_TITLE
#define FUNC1_TITLE [Messkanal_1]
#endif

#ifndef FUNC1_BLOCKNUMBER
#define FUNC1_BLOCKNUMBER			1
#endif

#define FUNC1_DEFAULT_UNIT 1001 //Grad Celsius

#ifdef FUNC1_DEFAULT_UNIT
#define DEFAULT_VALUE_func1_AI_out_unit    FUNC1_DEFAULT_UNIT
#endif

#ifndef DEFAULT_VALUE_func1_upper_range_value
#define DEFAULT_VALUE_func1_upper_range_value	100.0
#endif

#ifndef DEFAULT_VALUE_func1_lower_range_value
#define DEFAULT_VALUE_func1_lower_range_value	0.0
#endif

#ifndef DEFAULT_VALUE_func1_AI_hi_hi_lim
#define DEFAULT_VALUE_func1_AI_hi_hi_lim FLOAT_MAX
#endif

#ifndef DEFAULT_VALUE_func1_AI_hi_lim
#define DEFAULT_VALUE_func1_AI_hi_lim FLOAT_MAX
#endif

#ifndef DEFAULT_VALUE_func1_AI_lo_lim
#define DEFAULT_VALUE_func1_AI_lo_lim FLOAT_MIN
#endif

#ifndef DEFAULT_VALUE_func1_AI_lo_lo_lim
#define DEFAULT_VALUE_func1_AI_lo_lo_lim FLOAT_MIN
#endif

#ifndef DEFAULT_VALUE_func1_AI_out_unit
#define DEFAULT_VALUE_func1_AI_out_unit	32
#endif

#define FUNC1_UNIT_LIST UNIT_LIST_TESTO

#define NO_func1_AI_out_unit_text

#ifndef NO_func1_AI_out_unit_text
#ifndef	FUNC1_UNIT_LIST
#define FUNC1_UNIT_LIST	UNIT_LIST, {	1995,	func1_AI_out_unit_text}
#endif
#else
#ifndef	FUNC1_UNIT_LIST
#define FUNC1_UNIT_LIST	UNIT_LIST
#endif
#endif

#ifndef	FUNC1_UNIT_LIST
#define FUNC1_UNIT_LIST	UNIT_LIST, {	1995,	func1_AI_out_unit_text}
#endif


#ifndef MAX_VALUE_func1_AI_pv_ftime
#define MAX_VALUE_func1_AI_pv_ftime		300
#endif

#ifndef DEFAULT_VALUE_func1_AI_pv_ftime
#define DEFAULT_VALUE_func1_AI_pv_ftime		1
#endif


#define THERMO_RESISTANCE_CHANNEL         0x0109 // HiByte: Slot 1, LOWBYTE: rel Index PV = 8
#define TB_2_PV_1                         0x0208 // HiByte: Slot 2, LOWBYTE: rel Index PV = 8


#define FUNC1_CHANNEL_LIST \
		{	THERMO_RESISTANCE_CHANNEL, "0x0109"  }, \
		{	TB_2_PV_1,      	         "0x0208"  }

/// MACRO NO_UNIT_RELATION_out_scale_unit: Disable the UNIT relation for func1_AI_out_unit.


// -------------------------------------------------------------------------------------------------------------------------------------------------------------
/**************************************************/
/******************* Macros ***********************/
/**************************************************/

#define FUNC1_VARIABLES					\
	func1_AI_channel,						\
	func1_AI_strategy,					\
	func1_AI_alert_key,					\
	func1_AI_tag_desc,					\
	func1_AI_pv_upper_range_value,		\
	func1_AI_pv_lower_range_value,		\
	func1_AI_out_unit,					\
	func1_AI_out_upper_range_value,		\
	func1_AI_out_lower_range_value,		\
	func1_AI_pv_ftime,					\
	func1_AI_alarm_hys,					\
	func1_AI_hi_lim,						\
	func1_AI_lo_lim,						\
	func1_AI_hi_hi_lim,					\
	func1_AI_lo_lo_lim,					\
	func1_AI_out_decimal_point,			\
	func1_AI_batch_id,					\
	func1_AI_batch_unit,					\
	func1_AI_batch_operation,				\
	func1_AI_batch_phase 
	

#ifdef NO_func1_AI_out_unit_text
#define FUNC1_LOAD_TO_DEVICE		FUNC1_VARIABLES
#else
#define FUNC1_LOAD_TO_DEVICE		FUNC1_VARIABLES, func1_AI_out_unit_text
#endif



#define FUNC1_LOAD_TO_PC							\
      func1_AI_st_rev, func1_AI_actual_mode, FUNC1_LOAD_TO_DEVICE
      
/* WZ: func1_AI_actual_mode, aus obiger Zeile wieder rausschmeissen */


#define DEF_DISPLAY_FORMAT_FUNC1_AI(value)				\
		IF( (value > 999999999) || (value < -999999999) )	\
		{													\
			SELECT(func1_AI_out_decimal_point)	\
			{									\
				CASE 0:		".1g";				\
				CASE 1:		".2g";				\
				CASE 2:		".3g";				\
				CASE 3:		".4g";				\
				CASE 4:		".5g";				\
				CASE 5:		".6g";				\
				CASE 6:		".7g";				\
				CASE 7:		".8g";				\
				DEFAULT:	"8.4g" ;			\
			}									\
		}										\
		ELSE									\
		{										\
			SELECT(func1_AI_out_decimal_point)	\
			{									\
				CASE 0:		".0f";				\
				CASE 1:		".1f";				\
				CASE 2:		".2f";				\
				CASE 3:		".3f";				\
				CASE 4:		".4f";				\
				CASE 5:		".5f";				\
				CASE 6:		".6f";				\
				CASE 7:		".7f";				\
				DEFAULT:	"7.4f" ;			\
			}									\
		}



/**************************************************/
/*************** Windows and dialogs **************/
/**************************************************/

COLLECTION OF VARIABLE func1
{
	MEMBERS
	{
		actual_mode,		func1_AI_actual_mode,			FUNC1_TITLE ;
		simulation_enabled, func1_AI_simulation_enabled,	FUNC1_TITLE ;
		out,				func1_AI_out_value,			FUNC1_TITLE ;
		simulate_value,		func1_AI_simulate_value,		FUNC1_TITLE ;
	}
}


COLLECTION OF VARIABLE func1_short
{
	MEMBERS
	{
		alarm_sum, func1_AI_current_state_alarm_sum, [menu_dialog_alarm_sum] ;
	}
}



COLLECTION OF VARIABLE func1_blank
{
	MEMBERS
	{
		actual_mode,		func1_AI_actual_mode,			" " ;
		simulation_enabled, func1_AI_simulation_enabled,	" " ;
		out,				func1_AI_out_value,			" " ;
		lo_lo_alm_state,	func1_AI_lo_lo_alm_state,		" " ;
		lo_alm_state,		func1_AI_lo_alm_state,		" " ;
		hi_alm_state,		func1_AI_hi_alm_state,		" " ;
		hi_hi_alm_state,	func1_AI_hi_hi_alm_state,		" " ;
		lo_lo_alm_value,	func1_AI_lo_lo_alm_value,		" " ;
		lo_alm_value,		func1_AI_lo_alm_value,		" " ;
		hi_alm_value,		func1_AI_hi_alm_value,		" " ;
		hi_hi_alm_value,	func1_AI_hi_hi_alm_value,		" " ;
	}
}



MENU Val_func1_out_display
{
	LABEL		FUNC1_TITLE ;
	HELP		[func_ai_out_value_help];
	ITEMS
	{
		func1_AI_out_value
	}
}



MENU BarVal_out_display_func1
{
	LABEL		[func_out_value];
	HELP		[func_ai_out_value_help];
	ITEMS
	{
		func1_AI_out_value				(READ_ONLY),
		func1_AI_out_lower_range_value	(READ_ONLY),
		func1_AI_out_upper_range_value	(READ_ONLY)
	}
}



MENU Page_diagnosis_func1
{
	LABEL		FUNC1_TITLE ;
	ITEMS
	{
		func1_AI_blk_object,
		func1_AI_blk_parent_class,
		func1_AI_blk_class,
		func1_AI_blk_dd_reference,
		func1_AI_blk_dd_rev,
		func1_AI_blk_profile,
		func1_AI_blk_profile_rev,
		func1_AI_st_rev,
		func1_AI_actual_mode,
		func1_AI_simulation_enabled (READ_ONLY)
	}
}



MENU OnlineWindow_S_alarm_func1
{
	LABEL		FUNC1_TITLE ;
	ITEMS
	{
		Page_alarm_overview_func1
	}
}
/* Under OnlineWindow_S_alarm_func1 not supported in the T6680:
		Page_alarm_sum_func1,
		Page_alarm_hi_hi_alm_func1,
		Page_alarm_hi_alm_func1,
		Page_alarm_lo_alm_func1,
		Page_alarm_lo_lo_alm_func1
*/

MENU OnlineWindow_M_alarm_func1
{
	LABEL		FUNC1_TITLE ;
	ITEMS
	{
		Page_alarm_overview_func1,
		Page_alarm_sum_func1
	}
}
/* Under OnlineWindow_M_alarm_func1 not supported in the T6680:
		Page_alarm_hi_hi_alm_func1,
		Page_alarm_hi_alm_func1,
		Page_alarm_lo_alm_func1,
		Page_alarm_lo_lo_alm_func1
*/


MENU Page_alarm_overview_func1
{
	LABEL [menu_dialog_overview] ;
	HELP  [dialog_alarm_overview_help] ;
	ITEMS
	{
		func1_AI_hi_hi_lim (READ_ONLY),
		func1_AI_hi_lim (READ_ONLY),
		func1_AI_lo_lim (READ_ONLY),
		func1_AI_lo_lo_lim (READ_ONLY)
	}
}
/* Under Page_alarm_overview_func1 not supported in the T6680:
		SEPARATOR,
		func1_blank.hi_hi_alm_state,
		func1_blank.hi_alm_state,
		func1_blank.lo_alm_state,
		func1_blank.lo_lo_alm_state
		SEPARATOR,
		func1_blank.hi_hi_alm_value,
		func1_blank.hi_alm_value,
		func1_blank.lo_alm_value,
		func1_blank.lo_lo_alm_value
*/

MENU Page_alarm_hi_hi_alm_func1
{
	LABEL		[limit_hi_hi];
	ITEMS
	{
		func1_AI_hi_hi_alm_unacknowledged,
		func1_AI_hi_hi_alm_state,
		func1_AI_hi_hi_lim				(READ_ONLY),
		func1_AI_hi_hi_alm_value
	}
}
/* Under Page_alarm_hi_hi_alm_func1 not supported in the T6680:
		func1_AI_hi_hi_alm_time_stamp,		
		func1_AI_hi_hi_alm_subcode,      
*/


MENU Page_alarm_hi_alm_func1
{
	LABEL		[limit_hi];
	ITEMS
	{
		func1_AI_hi_alm_unacknowledged,
		func1_AI_hi_alm_state,
		func1_AI_hi_lim				(READ_ONLY),
		func1_AI_hi_alm_value
	}
}
/* Under Page_alarm_hi_alm_func1 not supported in the T6680:
		func1_AI_hi_alm_time_stamp,
		func1_AI_hi_alm_subcode, 
*/

MENU Page_alarm_lo_alm_func1
{
	LABEL		[limit_lo];
	ITEMS
	{
		func1_AI_lo_alm_unacknowledged,
		func1_AI_lo_alm_state,
		func1_AI_lo_lim				(READ_ONLY),
		func1_AI_lo_alm_value
	}
}
/* Under Page_alarm_lo_alm_func1 not supported in the T6680:
		func1_AI_lo_alm_time_stamp,
		func1_AI_hi_alm_subcode, 
*/


MENU Page_alarm_lo_lo_alm_func1
{
	LABEL		[limit_lo_lo];
	ITEMS
	{
		func1_AI_lo_lo_alm_unacknowledged,
		func1_AI_lo_lo_alm_state,
		func1_AI_lo_lo_lim				(READ_ONLY),
		func1_AI_lo_lo_alm_value
	}
}
/* Under Page_alarm_lo_lo_alm_func1 not supported in the T6680:
		func1_AI_lo_lo_alm_time_stamp,
		func1_AI_hi_alm_subcode,

*/

MENU Page_alarm_sum_func1
{
	LABEL		[menu_dialog_alarm_sum];
	ITEMS
	{
	    func1_AI_current_state_alarm_sum,
		func1_AI_unacknowledged_state_alarm_sum,
		SEPARATOR,
		func1_AI_unreported_state_alarm_sum,
		func1_AI_disabled_state_alarm_sum
	}
}

MENU Page_display_func1
{
	LABEL       FUNC1_TITLE ;
	ITEMS
	{
#ifdef FUNC1_TAG_IN_TABLE
		func1_AI_tag_desc,
#endif
		BarVal_out_display_func1,
		Group_display_func1_out,
		Group_display_func1_in
	}
}

MENU Group_display_func1
{
	LABEL		FUNC1_TITLE ;
	ITEMS
	{
		BarVal_out_display_func1,
		func1_AI_out_status_quality	(READ_ONLY),
		func1_AI_out_status_limit		(READ_ONLY),
	    func1_short.alarm_sum
	}
}

MENU Group_display_func1_out
{
	LABEL		[menu_dialog_display_output] ;
	ITEMS
	{
		func1_AI_actual_mode,
		SEPARATOR,
		func1_AI_out_status_quality	(READ_ONLY),
		func1_AI_out_status_limit		(READ_ONLY),
	    func1_short.alarm_sum
	}
}

MENU Group_display_func1_in
{
	LABEL		[menu_dialog_display_input] ;
	ITEMS
	{
#ifdef FUNC1_PV
		FUNC1_PV,
#endif

#ifdef FUNC1_CHANNEL_LIST
		func1_AI_channel				(READ_ONLY),
#endif

	SEPARATOR,

#ifdef FUNC1_PV_STATUS
		FUNC1_PV_STATUS,
#endif
		func1_AI_simulation_enabled (READ_ONLY)
	}
}


MENU OnlineDialog_simulation_func1
{
	LABEL		FUNC1_TITLE ;
	ITEMS
	{
		Page_simulation_input_func1,
		Page_simulation_output_func1
	}
}

MENU Page_simulation_input_func1
{
	LABEL		[menu_dialog_simulation_input];
	ITEMS
	{
		func1_AI_simulation_enabled,
		Group_simulate_input_func1,
		method_set
	}
}

MENU Group_simulate_input_func1
{
	LABEL		[func_simulate_value];
	ITEMS
	{
		func1_AI_simulate_value,
		SEPARATOR,
		func1_AI_simulate_status_quality,
		func1_AI_simulate_status_limit
	}
}

MENU Page_simulation_output_func1
{
	LABEL		[menu_dialog_simulation_output];
	ITEMS
	{
		func1_AI_target_mode,
		func1_AI_actual_mode,
		Group_simulate_output_func1,
		method_set
	}
}

MENU Group_simulate_output_func1
{
	LABEL		[func_out_value];
	ITEMS
	{
		func1_AI_out_value,
		SEPARATOR,
		func1_AI_out_status_quality,
		func1_AI_out_status_limit
	}
}



// --- Parameter table --------------------------------------------------------------

MENU Tab_s_func1
{
	LABEL		FUNC1_TITLE ;
	ITEMS
	{
		func1_AI_st_rev,

#ifdef FUNC1_TAG_IN_TABLE
		func1_AI_tag_desc,
#endif

#ifdef FUNC1_CHANNEL_LIST
		func1_AI_channel,
#endif

		func1_AI_out_unit,
#ifndef NO_func1_AI_out_unit_text
		func1_AI_out_unit_text,
#endif
		func1_AI_pv_ftime,
		Tab_s_func1_batch,
		Tab_s_func1_pv_range,
		Tab_s_func1_outscale,
		Tab_s_func1_limits,
		Tab_s_func1_interface
	}
}


MENU Tab_m_func1
{
	LABEL		FUNC1_TITLE ;
	ITEMS
	{
		func1_AI_st_rev,

#ifdef FUNC1_TAG_IN_TABLE
		func1_AI_tag_desc (READ_ONLY),
#endif

#ifdef FUNC1_CHANNEL_LIST
		func1_AI_channel	(READ_ONLY),
#endif

		func1_AI_out_unit	(READ_ONLY),
#ifndef NO_func1_AI_out_unit_text
		func1_AI_out_unit_text (READ_ONLY),
#endif
		func1_AI_pv_ftime (READ_ONLY),
		Tab_s_func1_batch,
		Tab_m_func1_pv_range,
		Tab_m_func1_outscale,
		Tab_m_func1_limits,
		Tab_s_func1_interface
	}
}


MENU Tab_s_func1_batch
{
	LABEL		[menu_ident_batch_info];
	ITEMS
	{
			func1_AI_batch_id,
			func1_AI_batch_unit,
			func1_AI_batch_operation,
			func1_AI_batch_phase
	}
}

MENU Tab_s_func1_pv_range
{
	LABEL		[menu_input_measwindow];
	ITEMS
	{
		func1_AI_pv_lower_range_value,
		func1_AI_pv_upper_range_value
	}
}

MENU Tab_s_func1_outscale
{
	LABEL		[menu_output_scalewindow];
	ITEMS
	{
		func1_AI_out_lower_range_value,
		func1_AI_out_upper_range_value,
	}
}


MENU Tab_m_func1_pv_range
{
	LABEL		[menu_input_measwindow];
	ITEMS
	{
		func1_AI_pv_lower_range_value	(READ_ONLY),
		func1_AI_pv_upper_range_value	(READ_ONLY)
	}
}

MENU Tab_m_func1_outscale
{
	LABEL		[menu_output_scalewindow];
	ITEMS
	{
		func1_AI_out_lower_range_value	(READ_ONLY),
		func1_AI_out_upper_range_value	(READ_ONLY)
	}
}


MENU Tab_s_func1_limits
{
	LABEL		[menu_output_limits];
	ITEMS
	{
		func1_AI_lo_lo_lim,
		func1_AI_lo_lim,
		func1_AI_hi_lim,
		func1_AI_hi_hi_lim,
		func1_AI_alarm_hys
	}
}


MENU Tab_m_func1_limits
{
	LABEL		[menu_output_limits];
	ITEMS
	{
		func1_AI_lo_lo_lim (READ_ONLY),
		func1_AI_lo_lim (READ_ONLY),
		func1_AI_hi_lim (READ_ONLY),
		func1_AI_hi_hi_lim (READ_ONLY),
		func1_AI_alarm_hys (READ_ONLY)
	}
}


MENU Tab_s_func1_interface
{
	LABEL		[menu_interface];
	ITEMS
	{
		func1_AI_out_decimal_point
	}
}

/**************************************************/
/************** AI Block Parameter ****************/
/**************************************************/


BLOCK function_block_1
{
	TYPE	FUNCTION;
	NUMBER	FUNC1_BLOCKNUMBER ;
}

VARIABLE func1_AI_blk_reserve
{
	LABEL		[blk_reserved];
	HELP		[blk_reserved_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func1_AI_blk_object
{
	LABEL		[blk_block_object];
	HELP		[blk_block_object_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	2,	[blk_block_object_FUNCTION]		}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_blk_parent_class
{
	LABEL		[blk_parent_class];
	HELP		[func_blk_parent_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	1,	[func_blk_parent_class_INPUT]	}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_blk_class
{
	LABEL		[blk_class];
	HELP		[func_blk_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	1,	[func_blk_class_AI]			}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_blk_dd_reference
{
	LABEL		[blk_dd_reference];
	HELP		[blk_dd_reference_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (4);
	HANDLING	READ;
}

VARIABLE func1_AI_blk_dd_rev
{
	LABEL		[blk_dd_rev];
	HELP		[blk_dd_rev_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(2);
	HANDLING	READ;
}

VARIABLE func1_AI_blk_profile
{
	LABEL		[blk_profile];
	HELP		[blk_profile_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
#ifdef DEFAULT_VALUE_phys_blk_profile
		DEFAULT_VALUE_phys_blk_profile
#endif
		{ 0x4001,	[blk_profile_PA_COMPACT_A]	},
		{ 0x4002,	[blk_profile_PA_COMPACT_B]	},
		{ 0x4081,	[blk_profile_PA_SIMPLE_A]	},
		{ 0x4082,	[blk_profile_PA_SIMPLE_B]	}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_blk_profile_rev
{
	LABEL		[blk_profile_rev];
	HELP		[blk_profile_rev_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
#ifdef CHECK_PROFILE_REV
		DEFAULT_VALUE	CHECK_PROFILE_REV ;
#else
		DEFAULT_VALUE	0x0300;
#endif
		{	0x025A,	"2.90"	},
		{	0x025B,	"2.91"	},
		{	0x025C,	"2.92"	},
		{	0x025D,	"2.93"	},
		{	0x025E,	"2.94"	},
		{	0x025F,	"2.95"	},
		{	0x0260,	"2.96"	},
		{	0x0261,	"2.97"	},
		{	0x0262,	"2.98"	},
		{	0x0263,	"2.99"	},
		{	0x0300,	"3.0"	  },
		{	0x0301,	"3.01"	}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_blk_execution_time
{
	LABEL		[blk_execution_time];
	HELP		[blk_execution_time_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(1);
	HANDLING	READ;
}

VARIABLE func1_AI_blk_num_parameters
{
	LABEL		[blk_num_parameters];
	HELP		[blk_num_parameters_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func1_AI_blk_index_view_1
{
	LABEL		[blk_index_view_1];
	HELP		[blk_index_view_1_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func1_AI_blk_num_view_lists
{
	LABEL		[blk_num_view_lists];
	HELP		[blk_num_view_lists_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func1_AI_st_rev
{
	LABEL		[st_rev];
	HELP		[st_rev_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ;
}

VARIABLE func1_AI_tag_desc
{
	LABEL		[tag_desc];
	HELP		[tag_desc_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32);
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_strategy
{
	/* ST_REV */
	LABEL		[strategy];
	HELP		[strategy_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_alert_key
{
	LABEL		[alert_key];
	HELP		[alert_key_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}


VARIABLE func1_AI_alarm_hys
{
	LABEL		[limit_hysteresis];
	HELP		[limit_hysteresis_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		// MIN_VALUE 0 ; problems with temperature units
		DEFAULT_VALUE (func1_AI_out_upper_range_value - func1_AI_out_lower_range_value) / 100 ;
		DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC1_AI(func1_AI_alarm_hys)
	}
	HANDLING	READ & WRITE;

	POST_EDIT_ACTIONS
	{
		method_check_func1_AI_alarm_hys
	}
}


VARIABLE func1_AI_hi_hi_lim
{
	LABEL		[limit_hi_hi];
	HELP		[limit_hi_hi_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE DEFAULT_VALUE_func1_AI_hi_hi_lim ;
		DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC1_AI(func1_AI_hi_hi_lim)

#ifdef MAX_VALUE_func1_AI_hi_hi_lim
	MAX_VALUE MAX_VALUE_func1_AI_hi_hi_lim ;
#endif

#ifdef MIN_VALUE_func1_AI_hi_hi_lim
	MIN_VALUE MIN_VALUE_func1_AI_hi_hi_lim ;
#endif
	}
	HANDLING	READ & WRITE;

	POST_EDIT_ACTIONS
	{
		method_check_func1_AI_alarm_hys
	}
}

VARIABLE func1_AI_hi_lim
{
	LABEL		[limit_hi];
	HELP		[limit_hi_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE DEFAULT_VALUE_func1_AI_hi_lim ;
		DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC1_AI(func1_AI_hi_lim)

#ifdef MAX_VALUE_func1_AI_hi_lim
	MAX_VALUE MAX_VALUE_func1_AI_hi_lim ;
#endif

#ifdef MIN_VALUE_func1_AI_hi_lim
	MIN_VALUE MIN_VALUE_func1_AI_hi_lim ;
#endif
	}
	HANDLING	READ & WRITE;

	POST_EDIT_ACTIONS
	{
		method_check_func1_AI_alarm_hys
	}
}


VARIABLE func1_AI_lo_lim
{
	LABEL		[limit_lo];
	HELP		[limit_lo_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE DEFAULT_VALUE_func1_AI_lo_lim ;
		DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC1_AI(func1_AI_lo_lim)

#ifdef MAX_VALUE_func1_AI_lo_lim
	MAX_VALUE MAX_VALUE_func1_AI_lo_lim ;
#endif

#ifdef MIN_VALUE_func1_AI_lo_lim
	MIN_VALUE MIN_VALUE_func1_AI_lo_lim ;
#endif
	}
	HANDLING	READ & WRITE;

	POST_EDIT_ACTIONS
	{
		method_check_func1_AI_alarm_hys
	}
}


VARIABLE func1_AI_lo_lo_lim
{
	LABEL		[limit_lo_lo];
	HELP		[limit_lo_lo_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE DEFAULT_VALUE_func1_AI_lo_lo_lim ;
		DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC1_AI(func1_AI_lo_lo_lim)

#ifdef MAX_VALUE_func1_AI_lo_lo_lim
	MAX_VALUE MAX_VALUE_func1_AI_lo_lo_lim ;
#endif

#ifdef MIN_VALUE_func1_AI_lo_lo_lim
	MIN_VALUE MIN_VALUE_func1_AI_lo_lo_lim ;
#endif

	}
	HANDLING	READ & WRITE;

	POST_EDIT_ACTIONS
	{
		method_check_func1_AI_alarm_hys
	}
}

VARIABLE func1_AI_pv_ftime
{
	LABEL		[func_pv_ftime];
	HELP		[func_pv_ftime_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	DEFAULT_VALUE_func1_AI_pv_ftime ;
		MIN_VALUE		0.0;
		MAX_VALUE		MAX_VALUE_func1_AI_pv_ftime ;
	}
	CONSTANT_UNIT	[sec];
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_channel
{
	LABEL		[func_channel];
	HELP		[func_channel_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (2)
	{
//#ifdef FUNC1_CHANNEL_LIST
		DEFAULT_VALUE	THERMO_RESISTANCE_CHANNEL;
		FUNC1_CHANNEL_LIST
//#else
//		{ 0x111,	"pv"		}
//#endif
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_target_mode
{
	LABEL		[target_mode];
	HELP		[target_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0x08;
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_actual_mode
{
	LABEL		[actual_mode];
	HELP		[actual_mode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0x08;
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_permitted_mode
{
	LABEL		[permitted_mode];
	HELP		[permitted_mode_help];
	CLASS		CONTAINED;
	TYPE		BIT_ENUMERATED (1)
	{
		DEFAULT_VALUE	0x08;
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_normal_mode
{
	LABEL		[normal_mode];
	HELP		[normal_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0x08;
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

func1_AI_current_state_alarm_sum				LIKE VARIABLE	phys_current_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]		},
		{	0x0400,	[limit_state_HI]		},
		{	0x0800,	[limit_state_LO_LO]		},
		{	0x1000,	[limit_state_LO]		},
		{	0x8000,	[limit_state_ST_REV]	}
	}
#ifdef _V510_
	REDEFINE STYLE "MULTILINE 12 7" ;
#endif
}

func1_AI_unacknowledged_state_alarm_sum		LIKE VARIABLE	phys_unacknowledged_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]		},
		{	0x0400,	[limit_state_HI]		},
		{	0x0800,	[limit_state_LO_LO]		},
		{	0x1000,	[limit_state_LO]		},
		{	0x8000,	[limit_state_ST_REV]	}
	}
#ifdef _V510_
	REDEFINE STYLE "MULTILINE 12 7" ;
#endif
}

func1_AI_unreported_state_alarm_sum			LIKE VARIABLE	phys_unreported_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]		},
		{	0x0400,	[limit_state_HI]		},
		{	0x0800,	[limit_state_LO_LO]		},
		{	0x1000,	[limit_state_LO]		},
		{	0x8000,	[limit_state_ST_REV]	}
	}
#ifdef _V510_
	REDEFINE STYLE "MULTILINE 12 7" ;
#endif
}

func1_AI_disabled_state_alarm_sum				LIKE VARIABLE	phys_disabled_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]		},
		{	0x0400,	[limit_state_HI]		},
		{	0x0800,	[limit_state_LO_LO]		},
		{	0x1000,	[limit_state_LO]		},
		{	0x8000,	[limit_state_ST_REV]	}
	}
#ifdef _V510_
	REDEFINE STYLE "MULTILINE 12 7" ;
#endif
}

VARIABLE func1_AI_batch_id
{
	LABEL		[func_batch_id];
	HELP		[func_batch_id_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (4)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_batch_unit
{
	LABEL		[func_batch_unit];
	HELP		[func_batch_unit_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_batch_operation
{
	LABEL		[func_batch_operation];
	HELP		[func_batch_operation_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_batch_phase
{
	LABEL		[func_batch_phase];
	HELP		[func_batch_phase_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_out_value
{
	LABEL		[func_out_value];
	HELP		[func_ai_out_value_help];
	CLASS		OUTPUT & DYNAMIC;
	TYPE        FLOAT
	{
		DEFAULT_VALUE	0.0;
		DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC1_AI(func1_AI_out_value)
	}
	HANDLING
		IF (func1_AI_target_mode == BLOCK_MODE_MAN)
		{
			READ & WRITE;
		}
		ELSE {
			READ;
		}
}

VARIABLE func1_AI_out_status_quality
{
	LABEL		[status_quality];
	HELP		[func_out_status_help];
	CLASS		OUTPUT & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		IF (func1_AI_target_mode == BLOCK_MODE_MAN)
		{
			STATUS_INPUT_NO_RCAS
		}
		ELSE {
			STATUS_OUTPUT_NO_RCAS
		}
	}
	POST_EDIT_ACTIONS
	{
		IF (func1_AI_target_mode == BLOCK_MODE_MAN)
		{
			method_set_status_limit_1
		}
	}
	HANDLING
		IF (func1_AI_target_mode == BLOCK_MODE_MAN)
		{
			READ & WRITE;
		}
		ELSE {
			READ;
		}
}

func1_AI_out_status_limit						LIKE VARIABLE	func1_AI_out_status_quality
{
	REDEFINE LABEL		[status_limit];
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_INPUT_LIMIT (func1_AI_out_status_quality)
	}
}

VARIABLE func1_AI_pv_upper_range_value
{
	LABEL		[func_pv_scale_upper_value];
	HELP		[func_pv_scale_upper_value_help];
	CLASS		CONTAINED;
	TYPE        FLOAT
	{
		DEFAULT_VALUE DEFAULT_VALUE_func1_upper_range_value ;
		DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC1_AI(func1_AI_pv_upper_range_value)
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_pv_lower_range_value
{
	LABEL		[func_pv_scale_lower_value];
	HELP		[func_pv_scale_lower_value_help];
	CLASS		CONTAINED;
	TYPE        FLOAT
	{
		DEFAULT_VALUE DEFAULT_VALUE_func1_lower_range_value ;
		DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC1_AI(func1_AI_pv_lower_range_value)
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_out_upper_range_value
{
	LABEL		[func_upper_value];
	HELP		[func_out_scale_upper_value_help];
	CLASS		CONTAINED;
	TYPE        FLOAT
	{
		DEFAULT_VALUE DEFAULT_VALUE_func1_upper_range_value ;
		DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC1_AI(func1_AI_out_upper_range_value)
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_out_lower_range_value
{
	LABEL		[func_lower_value];
	HELP		[func_out_scale_lower_value_help];
	CLASS		CONTAINED;
	TYPE        FLOAT
	{
		DEFAULT_VALUE DEFAULT_VALUE_func1_lower_range_value ;
		DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC1_AI(func1_AI_out_lower_range_value)
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_out_unit
{
	LABEL		[digital_units];
	HELP		[digital_units_help];
	CLASS		CONTAINED & SERVICE;
	TYPE		ENUMERATED (2)
	{
#ifdef DEFAULT_VALUE_func1_AI_out_unit
		DEFAULT_VALUE DEFAULT_VALUE_func1_AI_out_unit ;
#endif
		FUNC1_UNIT_LIST
	}
	HANDLING	READ & WRITE;

#ifdef FUNC1_POST_EDIT_out_unit
	POST_EDIT_ACTIONS
	{
		FUNC1_POST_EDIT_out_unit
	}
#endif
}

VARIABLE func1_AI_out_decimal_point
{
	LABEL		[decimal_point];
	HELP		[decimal_point_help];
	CLASS		CONTAINED;
	TYPE		INTEGER (1)
	{
		DEFAULT_VALUE	2;
		{	0,   "0"		},
		{	1,   "1"		},
		{	2,   "2"		},
		{	3,   "3"		},
		{	4,   "4"		},
		{	5,   "5"		},
		{	6,   "6"		},
		{	7,   "7"		}
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_lin_type
{
	LABEL		[trans_lin_type];
	HELP		[trans_lin_type_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{ 0,	[linear]	}
	}
	HANDLING	READ & WRITE;
}
/* Not supported in the T6680:
VARIABLE func1_AI_FSafeType /* Art der Reaktion auf Sensorausfall 
{
	/* ST_REV 
	LABEL		[func_ao_fsafe_type];
	HELP		[func_ao_fsafe_type_help_PROFILE_3];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE    FUNC_AI_STORING_LAST_SETPOINT;
		{ 0,	[func_ai_fsafe_type_FAIL_SAFE_VALUE]		},
		{ 1,	[func_ai_fsafe_type_STORING_LAST_SETPOINT]	},
		{ 2,	[func_ai_fsafe_type_FAIL_SAFE_POSITION]		}
	}
   HANDLING		READ & WRITE;
}


VARIABLE func1_AI_FSafeValue /* Ersatzwert bei Sensorausfall 
{
   /* ST_REV 
   LABEL		[func_ai_fsafe_value] ;
   HELP			[func_ai_fsafe_value_help];
   CLASS		CONTAINED;
   TYPE			FLOAT
   {
      DEFAULT_VALUE    0;
   }
   HANDLING		READ & WRITE;
   VALIDITY		IF (func1_AI_FSafeType == FUNC_AI_FAIL_SAFE_VALUE)
				{
					TRUE;
				}
				ELSE
				{
					FALSE;
				}
}
*/

VARIABLE func1_AI_hi_hi_alm_unacknowledged
{
	LABEL		[limit_alarm_unacknowledged];
	HELP		[limit_alarm_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func1_AI_hi_hi_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_hi_hi_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[limit_state_NO_ALARM]	},
		{	1,	[limit_state_HI_HI]		}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_hi_hi_alm_time_stamp
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE        TIME;
	HANDLING	READ;
}

VARIABLE func1_AI_hi_hi_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_hi_hi_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func1_AI_hi_hi_alm_value
{
	LABEL		[limit_alarm_value];
	HELP		[limit_hi_hi_alarm_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE func1_AI_hi_alm_unacknowledged
{
	LABEL		[limit_warn_unacknowledged];
	HELP		[limit_warn_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func1_AI_hi_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_hi_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[limit_state_NO_WARNING]	},
		{	1,	[limit_state_HI]			}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_hi_alm_time_stamp
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE        TIME;
	HANDLING	READ;
}

VARIABLE func1_AI_hi_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_hi_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func1_AI_hi_alm_value
{
	LABEL		[limit_warn_value];
	HELP		[limit_hi_warn_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE func1_AI_lo_alm_unacknowledged
{
	LABEL		[limit_warn_unacknowledged];
	HELP		[limit_warn_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func1_AI_lo_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_lo_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[limit_state_NO_WARNING]	},
		{	1,	[limit_state_LO]			}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_lo_alm_time_stamp
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE        TIME;
	HANDLING	READ;
}

VARIABLE func1_AI_lo_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_lo_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func1_AI_lo_alm_value
{
	LABEL		[limit_warn_value];
	HELP		[limit_lo_warn_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE func1_AI_lo_lo_alm_unacknowledged
{
	LABEL		[limit_alarm_unacknowledged];
	HELP		[limit_alarm_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func1_AI_lo_lo_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_lo_lo_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[limit_state_NO_ALARM]		},
		{	1,	[limit_state_LO_LO]			}
	}
	HANDLING	READ;
}

VARIABLE func1_AI_lo_lo_alm_time_stamp
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE        TIME;
	HANDLING	READ;
}

VARIABLE func1_AI_lo_lo_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_lo_lo_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func1_AI_lo_lo_alm_value
{
	LABEL		[limit_alarm_value];
	HELP		[limit_lo_lo_alarm_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE func1_AI_simulate_value
{
	LABEL		[func_simulate_value];
	HELP		[func_ai_simulate_value_help];
	CLASS		CONTAINED & SERVICE;
	TYPE        FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_simulate_status_quality
{
	LABEL		[status_quality];
	HELP		[func_simulate_status_help];
	CLASS		CONTAINED & SERVICE;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_NO_RCAS
	}
	POST_EDIT_ACTIONS
	{
		method_set_status_limit_1
	}
	HANDLING	READ & WRITE;
}

func1_AI_simulate_status_limit					LIKE VARIABLE	func1_AI_simulate_status_quality
{
	REDEFINE LABEL		[status_limit];
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_INPUT_LIMIT (func1_AI_simulate_status_quality)
	}
}

VARIABLE func1_AI_simulation_enabled
{
	LABEL		[func_simulation_enabled];
	HELP		[func_simulation_enabled_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[disabled]		},
		{	1,	[enabled]		}
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_AI_out_unit_text
{
	/* ST_REV */
   LABEL         [func_out_unit_text];
   HELP          [func_out_unit_text_help];
   CLASS         CONTAINED;
   TYPE          ASCII(16);
   HANDLING      READ & WRITE;
/*
   VALIDITY		IF( func1_AI_out_unit == 1995 )
				{
					TRUE ;
				}
				ELSE
				{
					FALSE ;
				}
*/
}


/**************************************************/
/************ AI Block Commands *******************/
/**************************************************/

COMMAND read_func1_AI_blk
{
	BLOCK function_block_1;
	INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_blk_reserve, func1_AI_blk_object, func1_AI_blk_parent_class, func1_AI_blk_class,
			func1_AI_blk_dd_reference, func1_AI_blk_dd_rev, func1_AI_blk_profile, func1_AI_blk_profile_rev,
			func1_AI_blk_execution_time, func1_AI_blk_num_parameters, func1_AI_blk_index_view_1,
			func1_AI_blk_num_view_lists
		}
	}
}

COMMAND read_func1_AI_st_rev
{
	BLOCK function_block_1;
	INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_st_rev
		}
	}
}

COMMAND read_func1_AI_tag_desc
{
	BLOCK function_block_1;
	INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_tag_desc
		}
	}
}

COMMAND write_func1_AI_tag_desc
{
	BLOCK function_block_1;
	INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_strategy
{
	BLOCK function_block_1;
	INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_strategy
		}
	}
}

COMMAND write_func1_AI_strategy
{
	BLOCK function_block_1;
	INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_alert_key
{
	BLOCK function_block_1;
	INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_alert_key
		}
	}
}

COMMAND write_func1_AI_alert_key
{
	BLOCK function_block_1;
	INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_target_mode
{
	BLOCK function_block_1;
	INDEX 5;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_target_mode
		}
	}
}

COMMAND write_func1_AI_target_mode
{
	BLOCK function_block_1;
	INDEX 5;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_mode
{
	BLOCK function_block_1;
	INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			 func1_AI_actual_mode, func1_AI_permitted_mode, func1_AI_normal_mode
		}
	}
}

COMMAND read_func1_AI_alarm
{
	BLOCK function_block_1;
	INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_current_state_alarm_sum, func1_AI_unacknowledged_state_alarm_sum,
			func1_AI_unreported_state_alarm_sum, func1_AI_disabled_state_alarm_sum
		}
	}
}

COMMAND read_func1_AI_batch_information
{
	BLOCK function_block_1;
	INDEX 8;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_batch_id, func1_AI_batch_unit, func1_AI_batch_operation, func1_AI_batch_phase
		}
	}
}

COMMAND write_func1_AI_batch_information
{
	BLOCK function_block_1;
	INDEX 8;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_batch_id, func1_AI_batch_unit, func1_AI_batch_operation, func1_AI_batch_phase
		}
		REPLY
		{
		}
	}
}



COMMAND read_func1_AI_out
{
	BLOCK function_block_1;
	INDEX 10;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_out_value,
			func1_AI_out_status_quality	<0xFC>,
			func1_AI_out_status_limit		<0x03>,
		}
	}
}

COMMAND write_func1_AI_out
{
	BLOCK function_block_1;
	INDEX 10;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_out_value,
			func1_AI_out_status_quality	<0xFC>,
			func1_AI_out_status_limit		<0x03>,
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_pv
{
	BLOCK function_block_1;
	INDEX 11;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_pv_upper_range_value, func1_AI_pv_lower_range_value
		}
	}
}

COMMAND write_func1_AI_pv
{
	BLOCK function_block_1;
	INDEX 11;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_pv_upper_range_value, func1_AI_pv_lower_range_value
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_out_scale
{
	BLOCK function_block_1;
	INDEX 12;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_out_upper_range_value,	func1_AI_out_lower_range_value,
			func1_AI_out_unit, func1_AI_out_decimal_point
		}
	}
}

COMMAND write_func1_AI_out_scale
{
	BLOCK function_block_1;
	INDEX 12;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_out_upper_range_value, func1_AI_out_lower_range_value,
			func1_AI_out_unit, func1_AI_out_decimal_point
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_lin_type
{
	BLOCK function_block_1;
	INDEX 13;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_lin_type
		}
	}
}

COMMAND write_func1_AI_lin_type
{
	BLOCK function_block_1;
	INDEX 13;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_lin_type
		}
		REPLY
		{
		}
	}
}



// --- Index 14: channel

COMMAND read_func1_AI_channel
{
	BLOCK function_block_1;
	INDEX 14;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_channel
		}
	}
}

COMMAND write_func1_AI_channel
{
	BLOCK function_block_1;
	INDEX 14;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_channel
		}
		REPLY
		{
		}
	}
}


// --- Index 16: pv_ftime

COMMAND read_func1_AI_pv_ftime
{
	BLOCK function_block_1;
	INDEX 16;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_pv_ftime
		}
	}
}

COMMAND write_func1_AI_pv_ftime
{
	BLOCK function_block_1;
	INDEX 16;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_pv_ftime
		}
		REPLY
		{
		}
	}
}

/* Not supported in the T6680:
COMMAND read_func1_AI_FSafeType
{
	BLOCK function_block_1;
	INDEX 17;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_FSafeType
		}
	}
}

COMMAND write_func1_AI_FSafeType
{
	BLOCK function_block_1;
	INDEX 17;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_FSafeType
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_FSafeValue
{
	BLOCK function_block_1;
	INDEX 18;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_FSafeValue
		}
	}
}

COMMAND write_func1_AI_FSafeValue
{
	BLOCK function_block_1;
	INDEX 18;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_FSafeValue
		}
		REPLY
		{
		}
	}
}
*/

COMMAND read_func1_AI_alarm_hys
{
	BLOCK function_block_1;
	INDEX 19;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_alarm_hys
		}
	}
}

COMMAND write_func1_AI_alarm_hys
{
	BLOCK function_block_1;
	INDEX 19;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_alarm_hys
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_hi_hi_lim
{
	BLOCK function_block_1;
	INDEX 21;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_hi_hi_lim
		}
	}
}

COMMAND write_func1_AI_hi_hi_lim
{
	BLOCK function_block_1;
	INDEX 21;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_hi_hi_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_hi_lim
{
	BLOCK function_block_1;
	INDEX 23;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_hi_lim
		}
	}
}

COMMAND write_func1_AI_hi_lim
{
	BLOCK function_block_1;
	INDEX 23;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_hi_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_lo_lim
{
	BLOCK function_block_1;
	INDEX 25;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_lo_lim
		}
	}
}

COMMAND write_func1_AI_lo_lim
{
	BLOCK function_block_1;
	INDEX 25;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_lo_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_lo_lo_lim
{
	BLOCK function_block_1;
	INDEX 27;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_lo_lo_lim
		}
	}
}

COMMAND write_func1_AI_lo_lo_lim
{
	BLOCK function_block_1;
	INDEX 27;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_lo_lo_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_AI_hi_hi_alm
{
	BLOCK function_block_1;
	INDEX 30;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_hi_hi_alm_unacknowledged, func1_AI_hi_hi_alm_state,
			func1_AI_hi_hi_alm_time_stamp, func1_AI_hi_hi_alm_subcode,
			func1_AI_hi_hi_alm_value
		}
	}
}

COMMAND read_func1_AI_hi_alm
{
	BLOCK function_block_1;
	INDEX 31;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_hi_alm_unacknowledged, func1_AI_hi_alm_state,
			func1_AI_hi_alm_time_stamp, func1_AI_hi_alm_subcode,
			func1_AI_hi_alm_value
		}
	}
}

COMMAND read_func1_AI_lo_alm
{
	BLOCK function_block_1;
	INDEX 32;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_lo_alm_unacknowledged, func1_AI_lo_alm_state,
			func1_AI_lo_alm_time_stamp, func1_AI_lo_alm_subcode,
			func1_AI_lo_alm_value
		}
	}
}

COMMAND read_func1_AI_lo_lo_alm
{
	BLOCK function_block_1;
	INDEX 33;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_lo_lo_alm_unacknowledged, func1_AI_lo_lo_alm_state,
			func1_AI_lo_lo_alm_time_stamp, func1_AI_lo_lo_alm_subcode,
			func1_AI_lo_lo_alm_value
		}
	}
}

COMMAND read_func1_AI_simulate
{
	BLOCK function_block_1;
	INDEX 34;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_AI_simulate_status_quality	<0xFC>,
			func1_AI_simulate_status_limit		<0x03>,
			func1_AI_simulate_value,
			func1_AI_simulation_enabled
		}
	}
}

COMMAND write_func1_AI_simulate
{
	BLOCK function_block_1;
	INDEX 34;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_AI_simulate_status_quality	<0xFC>,
			func1_AI_simulate_status_limit		<0x03>,
			func1_AI_simulate_value,
			func1_AI_simulation_enabled
		}
		REPLY
		{
		}
	}
}

COMMAND  read_func1_AI_out_unit_text
{
     BLOCK function_block_1;
     INDEX 35;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               func1_AI_out_unit_text
          }
     }
}

COMMAND  write_func1_AI_out_unit_text
{
     BLOCK function_block_1;
     INDEX 35;
     OPERATION WRITE;
     TRANSACTION
     {
          REQUEST
          {
               func1_AI_out_unit_text
          }
          REPLY
          {
          }
     }
}

/*******************************************************************************/
/*****	Methods		************************************************************/
/*******************************************************************************/

METHOD method_set_status_limit_1
{
	CLASS		INPUT;
	DEFINITION
	{
		int	quality;
		int block_mode;			/* !!! temp.: bis Methoden mit Aufrufparametern funktionieren !!! */

		quality = ivar_value(func1_AI_simulate_status_quality);
		if ((quality == 0x20) || (quality == 0x30))
			iassign(func1_AI_simulate_status_limit, 0);

		block_mode	= ivar_value(func1_AI_target_mode);
		quality		= ivar_value(func1_AI_out_status_quality);
		if ((block_mode == BLOCK_MODE_MAN) && ((quality == 0x20) || (quality == 0x30)))
			iassign(func1_AI_out_status_limit, 0);
	}
}


// --- Parameter: alarm --------------------------------------------------------------
METHOD method_check_func1_AI_alarm_hys
{
	CLASS		INPUT;
	DEFINITION
	{
		float	hi_hi_lim, lo_lo_lim, hyst, hyst_new, fDiff ;
		long	var_id[2];

		hi_hi_lim = fvar_value(func1_AI_hi_hi_lim);
		lo_lo_lim = fvar_value(func1_AI_lo_lo_lim);
		fDiff = hi_hi_lim-lo_lo_lim ;
		hyst = fvar_value(func1_AI_alarm_hys);

		if( fDiff < 0 )
			fDiff = - fDiff ;

		if ((hyst < 0) || (hyst >= fDiff) )
		{
			hyst_new = fDiff * 0.05;
			fassign (func1_AI_alarm_hys, hyst_new);
			var_id[0] = VARID (func1_AI_alarm_hys);
			var_id[1] = VARID (func1_AI_out_unit);
			acknowledge ([alert_alarm_hys],var_id);
		}
	}
}

#ifndef NO_UNIT_RELATION_out_scale_unit
UNIT AI_1_OUT_SCALE_UNIT
{
	func1_AI_out_unit:

	func1_AI_out_value,
	func1_AI_out_upper_range_value,
	func1_AI_out_lower_range_value,
	func1_AI_alarm_hys,
	func1_AI_hi_hi_lim,
	func1_AI_hi_lim,
	func1_AI_lo_lim,
	func1_AI_lo_lo_lim,
	func1_AI_hi_hi_alm_value,
	func1_AI_hi_alm_value,
	func1_AI_lo_alm_value,
	func1_AI_lo_lo_alm_value
}
#endif

