/*===================================================================
 File name:	    T_6680_0A8A_IM.inc
 Date:      	  Aug. 21. 2006
---------------------------------------------------------------------
 DESCRIPTION:
 I&M functions
                                      
 DEVICE:
 T6680 Humidity Device 
---------------------------------------------------------------------
 Revision history:
 REV 0.01 DATE:210806	 TMG/WZ first release

===================================================================*/




/**************************************************/
/*************** Windows and dialogs **************/
/**************************************************/


#ifdef _V602_
MENU process_variables_root_menu
{
	LABEL "Online View";
	STYLE WINDOW;
	ITEMS
	{
		pageOnline1,
		pageOnline2 /*,
		pageOnline3 */
	}
}
#endif


MENU pageOnline1
{
	LABEL "General";
	ITEMS
	{
		MANUFACTURER_SPECIFIC_IM0 (HIDDEN),
    IM_VERSION,
		PROFILE_ID_HIBYTE,
    IM_SUPPORTED
	}
}



MENU pageOnline2
{
    LABEL       [menu_ident_device];
    ITEMS
    {
    	phys_device_man_id,
      ORDER_ID,
		  phys_device_ser_num,
		  phys_hardware_rev,
      phys_software_rev,
		  REV_COUNTER
	}
}



MENU pageOnline3
{
    LABEL       [menu_ident_opunit];
    ITEMS
    {
        TAG_FUNCTION			(READ_ONLY),
        TAG_LOCATION			(READ_ONLY),
        DESCRIPTOR				(READ_ONLY),
        INSTALLATION_DATE       (READ_ONLY),
        SIGNATURE               (READ_ONLY)
    }
}


// --- Parameter table ------------------------------------------------

// Die folgenden auskommentierten Zeilen werden schon im Physical Block generiert und angezeigt; keine Verwendung daher im T6680.

//MENU Table_Main_Specialist
//{
//	LABEL "Standard";
//	HELP  "Device that supports PROFIBUS I&M functions"
//			"|de|Gert das die PROFIBUS I&M Funktionen untersttzt";
//
//	ITEMS
//	{
//		Tab_Identification
//	}
//}
//
//

//MENU Tab_Identification
//{
//    LABEL       "Identification"
//                "|de|Identifikation"
//                "|fr|Identification"
//                "|it|Identificazione"
//                "|sp|Identificacin";
//    ACCESS      OFFLINE;
//    ITEMS
//    {
//        Tab_Operation_Unit,
//		Tab_Device
//    }
//}
//
//
//
//MENU Tab_Operation_Unit
//{
//    LABEL       [menu_ident_opunit];
//    ITEMS
//    {
//        TAG_FUNCTION,
//        TAG_LOCATION,
//        DESCRIPTOR,
//        INSTALLATION_DATE,
//        SIGNATURE
//    }
//}



//MENU Tab_Device
//{
//    LABEL       [menu_ident_device];
//    ITEMS
//    {
//		PROFILE_ID_HIBYTE,
//        MANUFACTURER_ID,
//        ORDER_ID,
//		SERIAL_NUMBER,
//		HARDWARE_REVISION,
//        SOFTWARE_REVISION,
//		IM_VERSION,
//		REV_COUNTER
//	}
//}


//MENU download_variables
//{
//	LABEL		[menu_load_to_PC];
//	PRE_READ_ACTIONS
//	{
//		DEFINITION
//		{
//			IM_INDEX = 65000;
//			WriteCommand(commandPRE_READ_IM);
//			ReadCommand(commandREAD_IM0);
//		}
//	}
//
//	ITEMS
//	{
//        MANUFACTURER_SPECIFIC_IM0,
//        MANUFACTURER_ID,
//        ORDER_ID,
//        SERIAL_NUMBER,
//        HARDWARE_REVISION,
//        SOFTWARE_REVISION_0,
//        SOFTWARE_REVISION_1,
//        SOFTWARE_REVISION_2,
//        SOFTWARE_REVISION_3,
//        REV_COUNTER,
//		PROFILE_ID_HIBYTE,
//		PROFILE_ID_LOBYTE,
//        PROFILE_SPECIFIC_TYPE,
//        IM_VERSION,
//        IM_SUPPORTED,
//
//		IF( (IM_SUPPORTED & 0x002) == 0x002 )
//		{
//			MANUFACTURER_SPECIFIC_IM1,
//			TAG_FUNCTION,
//			TAG_LOCATION,
//		}
//
//		IF( (IM_SUPPORTED & 0x004) == 0x004 )
//		{
//			MANUFACTURER_SPECIFIC_IM2,
//			INSTALLATION_DATE,
//		}
//
//		IF( (IM_SUPPORTED & 0x008) == 0x008 )
//		{
//			MANUFACTURER_SPECIFIC_IM3,
//			DESCRIPTOR,
//		}
//
//		IF( (IM_SUPPORTED & 0x010) == 0x010 )
//		{
//			MANUFACTURER_SPECIFIC_IM4,
//			SIGNATUR
//		}
//	}
//}

//MENU upload_variables
//{
//	LABEL		[menu_load_to_device];
//
//	PRE_WRITE_ACTIONS
//	{
//		DEFINITION
//		{
//			IM_INDEX = 65000;
//			WriteCommand(commandPRE_READ_IM);
//			ReadCommand(commandREAD_IM0);
//		}
//	}
//
//	ITEMS
//	{
//		IF( (IM_SUPPORTED & 0x002) == 0x002 )
//		{
//			MANUFACTURER_SPECIFIC_IM1,
//			TAG_FUNCTION,
//			TAG_LOCATION,
//		}
//
//		IF( (IM_SUPPORTED & 0x004) == 0x004 )
//		{
//			MANUFACTURER_SPECIFIC_IM2,
//			INSTALLATION_DATE,
//		}
//
//		IF( (IM_SUPPORTED & 0x008) == 0x008 )
//		{
//			MANUFACTURER_SPECIFIC_IM3,
//			DESCRIPTOR,
//		}
//
//		IF( (IM_SUPPORTED & 0x010) == 0x010 )
//		{
//			MANUFACTURER_SPECIFIC_IM4,
//			SIGNATUR
//		}
//	}
//}



/**************************************************/
/************** I&M VARIABLEs *********************/
/**************************************************/

VARIABLE IM_SUPPORTED
{
    LABEL       "Available I&M records"
                "|de|Verfgbare I&M Daten";
    HELP        "This parameter indicates the availability of I&M records."
                "|de|Implementierte Version der I&M Funktionen.";
    CLASS       CONTAINED;
    TYPE        BIT_ENUMERATED(2)
    {
		DEFAULT_VALUE 0x7f;

		{ 0x001, "Profile Specific I&M"},
		{ 0x002, "I&M 1"},
		{ 0x004, "I&M 2"},
		{ 0x008, "I&M 3"},
		{ 0x010, "I&M 4"},
		{ 0x020, "I&M 5"},
		{ 0x040, "I&M 6"}
	}
	HANDLING    READ;
	STYLE "MULTILINE 32 7";
}



VARIABLE TAG_FUNCTION
{
    LABEL       [tag_desc];
    HELP        [tag_desc_help];
    PURPOSE     "Device.App.Ident.TAG";
    TYPE        ASCII (32)
    {
    }
    HANDLING    READ & WRITE;
	VALIDITY	IF( (IM_SUPPORTED & 0x002) == 0x002 ) { TRUE ; } ELSE { FALSE ; }
}



VARIABLE TAG_LOCATION
{
    LABEL       "Tag location"
                "|de|Einbauort";
    HELP        "Tag location of the device"
                "|de|Einbauort, an dem die Baugruppe eingebaut ist";
    PURPOSE     "Device.App.Ident.Location";
    TYPE        ASCII (22);
    HANDLING    READ & WRITE;
	VALIDITY	IF( (IM_SUPPORTED & 0x002) == 0x002 ) { TRUE ; } ELSE { FALSE ; }
}



VARIABLE INSTALLATION_DATE
{
    LABEL       [phys_install_date];
    HELP        [phys_install_date_help];
    PURPOSE     "Device.App.Ident.InstallDate";
    TYPE        ASCII(16);
    HANDLING    READ & WRITE;
	VALIDITY	IF( (IM_SUPPORTED & 0x004) == 0x004 ) { TRUE ; } ELSE { FALSE ; }
}



VARIABLE IM2_RESERVED
{
    LABEL       "reserved";
    TYPE        OCTET(38);
    HANDLING    READ & WRITE;
}



VARIABLE DESCRIPTOR
{
    LABEL       [phys_descriptor];
    HELP        [phys_descriptor_help];
    PURPOSE     "Device.App.Ident.Description";
    TYPE        ASCII(54);
    HANDLING    READ & WRITE;
	VALIDITY	IF( (IM_SUPPORTED & 0x008) == 0x008 ) { TRUE ; } ELSE { FALSE ; }
}



VARIABLE SIGNATURE
{
    LABEL       "Signature"
                "|de|Signatur";
    HELP        "Reference for specific parameter settings"
                "|de|Referenz fr eine bestimmte Parametrierung.";
    TYPE        ASCII(54);
    HANDLING    READ & WRITE;
	VALIDITY	IF( (IM_SUPPORTED & 0x010) == 0x010 ) { TRUE ; } ELSE { FALSE ; }
}



VARIABLE MANUFACTURER_ID
{
    LABEL       [phys_device_man_id];
    PURPOSE     "Device.Type.Ident.Manufacturer";
    TYPE        ENUMERATED(2)
    {
		DEFAULT_VALUE 0xFC;

		{0x00, "Standard", ""},	// STANDARD
		{0x03, "Ametek", ""},	// AMETEK
		{0x0A, "Brooks Instrument", ""},	// BROOKS_INSTRUMENT
		{0x0E, "Delta", ""},	// DELTA
		{0x11, "Endress + Hauser", ""},	// ENDRESS_HAUSER
		{0x12, "Fisher & Porter", "BAILEY_FISCHER_AND_PORTER"},	// BAILEY_FISCHER_AND_PORTER
		{0x13, "Fisher Controls", ""},	// FISHER_CONTROLS
		{0x14, "Foxboro Eckardt", ""},	// FOXBORO
		{0x15, "Fuji", ""},	// FUJI
		{0x16, "Hartmann & Braun", "ABB"},	// HARTMANN_BRAUN
		{0x17, "Honeywell", ""},	// HONEYWELL
		{0x19, "Kay Ray Sensall", ""},	// KAY_RAY_SENSALL
		{0x1A, "ABB", ""},	// ABB
		{0x1D, "M System", ""},	// M_SYSTEM
		{0x1F, "Micro Motion", ""},	// MICRO_MOTION
		{0x20, "Moore Industries", ""},	// MOORE_INDUSTRIES
		{0x21, "Moore Products", ""},	// MOORE_PRODUCTS
		{0x25, "RONAN", ""},	// RONAN
		{0x26, "Rosemount", ""},	// ROSEMOUNT
		{0x27, "Peek Measurment", ""},	// PEEK_MEASUREMENT
		{0x28, "Schlumberger", ""},	// SCHLUMBERGER
		{0x2A, "SIEMENS", "Siemens AG"},	// SIEMENS
		{0x2C, "Toshiba", ""},	// TOSHIBA
		{0x2E, "Rosemount", ""},	// ROSEMOUNT_ANALYTICAL
		{0x2F, "Valmet", ""},	// VALMET
		{0x30, "Flowserve", ""},	// FLOWSERVE
		{0x32, "Viatran", ""},	// VIATRAN
		{0x33, "WEED", ""},	// WEED
		{0x36, "YAMATAKE", ""},	// YAMATAKE
		{0x37, "YOKOGAWA", ""},	// YOKOGAWA
		{0x3B, "Solartron Mobrey", ""},	// KDG_MOBREY
		{0x3D, "Princo", ""},	// PRINCO
		{0x3E, "Smar", ""},	// SMAR
		{0x3F, "Foxboro Eckardt", ""},	// ECKARDT
		{0x42, "Samson", "SAMSON devices"},	// SAMSON
		{0x43, "Sparling Instruments", ""},	// SPARLING_INSTRUMENTS
		{0x45, "Krohne", ""},	// KROHNE
		{0x47, "GE Druck", ""},	// GE_DRUCK
		{0x4D, "Westlock Controls", ""},	// WESTLOCK_CONTROLS
		{0x4E, "Drexelbrock", ""},	// DREXELBROOK
		{0x4F, "SAAB Tank Control", ""},	// SAAB_TANK_CONTROL
		{0x52, "Draeger", ""},	// DRAEGER
		{0x54, "SIEMENS Milltronics", "SIEMENS Milltronics"},	// SIEMENS_MILLTRONICS_P_I
		{0x56, "Magnetrol", ""},	// MAGNETROL
		{0x57, "Neles Jamesbury", ""},	// NELES_JAMESBURY
		{0x58, "SIEMENS Milltronics", "SIEMENS Milltronics"},	// MILLTRONICS
		{0x5A, "Anderson", ""},	// ANDERSON
		{0x5B, "Inor", ""},	// INOR
		{0x5C, "Robertshaw", ""},	// ROBERTSHAW
		{0x5D, "Pepperl + Fuchs", ""},	// PEPPERL_FUCHS
		{0x5E, "Accutech", ""},	// ACCUTECH
		{0x60, "Kamstrup", "Kamstrup Gerte"},	// KAMSTRUP
		{0x61, "Knick", "Knick elektronische Messgerte"},	// KNICK
		{0x62, "VEGA", ""},	// VEGA
		{0x63, "MTS Systems", ""},	// MTS_SYSTEMS
		{0x64, "OVAL", ""},	// OVAL
		{0x65, "Mansoneilan", ""},	// MASONEILAN
		{0x66, "BESTA", ""},	// BESTA
		{0x67, "OMARTH", ""},	// OHMART
		{0x68, "Harold Beck and Sons", ""},	// HAROLD_BECK_AND_SONS
		{0x6B, "WIKA", "WIKA Alexander Wiegand GmbH & Co"},	// WIKA
		{0x6C, "Bopp & Reuther Heinrichs", "Bopp & Reuther Heinrichs devices"},	// BOPP_AND_REUTHER_HEINRICHS
		{0x6D, "PR electronics", "PR electronics A/S"},	// PR_ELECTRONICS
		{0x71, "Aparatebau Hundsbach", ""},	// APPARATEBAU_HUNDSBACH
		{0x72, "Dynisco", ""},	// DYNISCO
		{0x73, "Spriano", ""},	// SPRIANO
		{0x74, "DMC", ""},	// DMC
		{0x75, "Klay Instruments", ""},	// KLAY_INSTRUMENTS
		{0x78, "Brkert", ""},	// BUERKERT
		{0x7C, "GLI", ""},	// GLI
		{0x7E, "PMC", ""},	// PMC
		{0x7F, "Labom Mess- und Regeltechnik GmbH", ""},	// LABOM
		{0x80, "Danfoss", "Danfoss Devices"},	// DANFOSS
		{0x81, "TURBO-WERK", ""},	// TURBO
		{0x83, "SMC", ""},	// SMC
		{0x84, "Status Instruments", ""},	// STATUS_INSTRUMENTS
		{0x85, "HUAKONG", ""},	// HUAKONG
		{0x87, "VORTEK", ""},	// VORTEK
		{0x89, "Action Instruments", ""},	// ACTION_INSTRUMENTS
		{0x8C, "Magtech", ""},	// MAGTECH
		{0x8D, "Rger", ""},	// RUEGER
		{0x8E, "Mettler Toledo", ""},	// METTLER_TOLEDO
		{0x8F, "Detector Electronics", ""},	// DETECTOR_ELECTRONICS
		{0x90, "Thermo Measure Tech", ""},	// THERMO_MEASURE_TECH
		{0x91, "DEZURIK", ""},	// DEZURIK
		{0x93, "WELLTECH", ""},	// WELLTECH
		{0x9A, "Milton Roy", ""},	// MILTON_ROY
		{0x9B, "PMV", ""},	// PMV
		{0x9C, "TURCK", ""},	// TURCK
		{0x9D, "Panametrics", ""},	// PANAMETRICS
		{0x9E, "Stahl", ""},	// STAHL
		{0x9F, "ATI", "Analytical Technology, Inc"},	// ATI
		{0xA0, "FINT", ""},	// FINT
		{0xA1, "Berthold", ""},	// BERTHOLD
		{0xA2, "Intercorr", ""},	// INTERCORR
		{0xA6, "Fluid Components", ""},	// FLUID_COMPONENTS
		{0xA9, "Invensys", "Invensys Systems Inc."},	// INVENSYS
		{0xAB, "Tyco Valves Control", ""},	// TYCO_VALVES_CONTROLS
		{0xAD, "J Tec", ""},	// J_Tec
		{0xAE, "SYNETIX", ""},	// SYNETIX
		{0xB0, "Phoenix Contact", ""},	// PHOENIX_CONTACT
		{0xB2, "American Level Instruments", ""},	// AMERICAN_LEVEL_INSTRUMENTS
		{0xB5, "Pyromation inc", ""},	// PYROMATION_INC
		{0xBD, "Badgermeter", ""},	// BADGERMETER
		{0xBF, "GP50", ""},	// GP50
		{0xC0, "Kongsberg Maritime", ""},	// KONGSBERG_MARITIME
		{0xC2, "Hengesbach", ""},	// HENGESBACH
		{0xC3, "Lanlian", ""},	// LANLIAN_INSTRUMENTS
		{0xC5, "KPM", ""},	// KPM
		{0xC7, "Sick Maihak", ""},	// SICK_MAIHAK
		{0xCA, "SPIRAX", ""},	// SPIRAX
		{0xD5, "HACH LANGE", "united for water quality"},	// HACH_LANGE
		{0xF9, "HCF", ""},	// HCF
		{0xFA, "Not Used", ""},	// NOT_USED
		{0xFB, "None", ""},	// NONE
		{0xFC, "Unknown", ""},	// UNKNOWN
		{0xFD, "Special", ""},	// SPECIAL
		{0x5D0, "BEKA", ""},	// BEKA
		{0x103, "Bosch Rexroth", "Bosch Rexroth AG - The Drive & Control Company"},	// BOSCHREXROTH
		{0x108, "Mitsubishi", "Mitsubishi Electric Europe B.V."},	// MITSUBISHI
		{0x109, "Moeller", "Moeller GmbH"},	// MOELLER
		{0x10A, "SEW_EURODRIVE", "SEW-EURODRIVE GmbH & Co."},	// SEW_EURODRIVE
		{0x10E, "BARTEC", "BARTEC GmbH"},	// BARTEC
		{0x142, "Testo AG", ""},
		{0x125 , "ROTORK", "Rotork Controls Ltd. "}	// ROTORK
    }
    HANDLING    READ;
}

VARIABLE SERIAL_NUMBER
{
    LABEL       "Serial Number"
                "|de|Seriennummer";
    HELP        "A serial number is a unique production number from the device manufacturer even for devices with the same hardware, software or firmware edition."
                "|de|Die Seriennummer ist eine eindeutige Produktionsnummer des Gerteherstellers sogar fr Gerte mit dem selben Hardware, Software oder Firmware Ausgabestand.";
    TYPE        ASCII(16);
    HANDLING    READ;
}


VARIABLE ORDER_ID
{
    LABEL       [phys_productcode];
    HELP        "This parameter contains the complete order number or at least a relevant part that allows unambigous identification of the device/module."
                "|de|Dieser Parameter enthlt die komplette Bestellnummer oder den relevanten Teil, der eine eindeutuge Identifikation des Gerts ermglicht.";
    PURPOSE     "Device.Type.Ident.OrderNumber";
    TYPE        ASCII (20);
    HANDLING    READ;
}



VARIABLE SOFTWARE_REVISION
{
	LABEL [phys_software_revision];
	TYPE ASCII(12);
	CLASS LOCAL;
	HANDLING READ;
	REFRESH_ACTIONS
	{
		methodUpdate_SOFTWARE_REVISION
	}

}


VARIABLE SOFTWARE_REVISION_0
{
	LABEL "Software Revision Byte 0";
	TYPE ASCII(1)
	{
		DEFAULT_VALUE "V";
	}
	HANDLING READ;
}

VARIABLE SOFTWARE_REVISION_1
{
	LABEL "Software Revision Byte 1";
	TYPE UNSIGNED_INTEGER(1)
	{
		DEFAULT_VALUE 1;
	}
	HANDLING READ;
}

VARIABLE SOFTWARE_REVISION_2
{
	LABEL "Software Revision Byte 2";
	TYPE UNSIGNED_INTEGER(1)
	{
		DEFAULT_VALUE 0;
	}
	HANDLING READ;
}

VARIABLE SOFTWARE_REVISION_3
{
	LABEL "Software Revision Byte 3";
	TYPE UNSIGNED_INTEGER(1)
	{
		DEFAULT_VALUE 0;
	}
	HANDLING READ;
}

VARIABLE HARDWARE_REVISION
{
    LABEL       [phys_hardware_revision];
	HELP		[phys_hardware_revision_help];
    PURPOSE     "Device.Type.Ident.HWRevision";
    TYPE        UNSIGNED_INTEGER(2)
    {
    }
    HANDLING    READ;
}


VARIABLE PROFILE_ID_HIBYTE
{
	LABEL "Profile ID";
	TYPE ENUMERATED(1)
	{
		{ 0xF6, "Generic device"},
		{ 0x3A, "PROFIdrive"},
		{ 0x3B, "Robots and Numeric Control"},
		{ 0x3C, "Display & Panel Devices"},
		{ 0x3D, "Encoder"},
		{ 0x3E, "PROFIsafe"},
		{ 0x3F, "Fluid Power / Hydraulics"},
		{ 0x4B, "Reserved"},
		{ 0x4C, "Reserved"},
		{ 0x4D, "Reserved"},
		{ 0x4E, "Reserved"},
		{ 0x4F, "Reserved"},
		{ 0x5A, "SEMI - Devices"},
		{ 0x5B, "Idenitification Systems"},
		{ 0x5C, "Weighing & Dosage Systems"},
		{ 0x5D, "Intelligent Pumps"},
		{ 0x5E, "Low Voltage Switchgear"},
		{ 0x5F, "Remote I/O for Process Control"},
		{ 0x62, "Laboratory Devices"},
		{ 0x6A, "Reserved"},
		{ 0x6B, "Reserved"},
		{ 0x6C, "Reserved"},
		{ 0x6D, "Reserved"},
		{ 0x6E, "Reserved"},
		{ 0x97, "PA Devices (for Process Control)"}
	}
	HANDLING READ;
}




VARIABLE PROFILE_ID_LOBYTE
{
	LABEL "Profile ID";
	TYPE UNSIGNED_INTEGER(1);
}



VARIABLE PROFILE_SPECIFIC_TYPE
{
	LABEL "Profile specific type";
	TYPE UNSIGNED_INTEGER(2);
}



VARIABLE IM_VERSION
{
	LABEL "I&M Version";
	TYPE UNSIGNED_INTEGER(2)
	{
		DEFAULT_VALUE 1;
	}
	HANDLING READ;
}



VARIABLE REV_COUNTER
{
	LABEL "Revision Counter";
	TYPE UNSIGNED_INTEGER(2);
	HANDLING READ;
}



VARIABLE MANUFACTURER_SPECIFIC_IM0
{
	LABEL "Manufacturer specific data";
	TYPE OCTET(10);
	HANDLING READ;
	PRE_READ_ACTIONS
	{
		methodPRE_READ_IM0
	}
}



VARIABLE MANUFACTURER_SPECIFIC_IM1
{
	LABEL "Manufacturer specific data";
	TYPE OCTET(10);
	HANDLING READ;
	PRE_READ_ACTIONS
	{
		methodPRE_READ_IM1
	}
}



VARIABLE MANUFACTURER_SPECIFIC_IM2
{
	LABEL "Manufacturer specific data";
	TYPE OCTET(10);
	HANDLING READ;
	PRE_READ_ACTIONS
	{
		methodPRE_READ_IM2
	}
}



VARIABLE MANUFACTURER_SPECIFIC_IM3
{
	LABEL "Manufacturer specific data";
	TYPE OCTET(10);
	HANDLING READ;
	PRE_READ_ACTIONS
	{
		methodPRE_READ_IM3
	}
}

VARIABLE MANUFACTURER_SPECIFIC_IM4
{
	LABEL "Manufacturer specific data";
	TYPE OCTET(10);
	HANDLING READ;
	PRE_READ_ACTIONS
	{
		methodPRE_READ_IM4
	}
}

VARIABLE IM_INDEX
{
	LABEL "IM Index";
	TYPE UNSIGNED_INTEGER(2);
}





/**************************************************/
/************ I&M  Commands ***''''****************/
/**************************************************/


COMMAND commandPRE_READ_IM
{
	SLOT 0;
	INDEX 255;
	OPERATION WRITE;
	TRANSACTION
	{
        REQUEST
        {
			0x08, 0x00,
			IM_INDEX
        }
        REPLY
        {
        }
	}
}

//COMMAND commandPRE_READ_IM
//{
//	SLOT 0;
//	INDEX 255;
//	OPERATION WRITE;
//	TRANSACTION
//	{
//        REQUEST
//        {
//			0x08, 0x00,
//			IM_INDEX
//        }
//        REPLY
//        {
//        }
//	}
//}




COMMAND commandREAD_IM0 // mandatory
{
	SLOT 0;
	INDEX 255;
	OPERATION READ;
	TRANSACTION
	{
        REQUEST
        {
        }
        REPLY
        {
			0x08, 0x00,
			0xFD, 0xE8,	// IM_INDEX 65000

            MANUFACTURER_SPECIFIC_IM0,
            MANUFACTURER_ID,
            ORDER_ID,
            SERIAL_NUMBER,
            HARDWARE_REVISION,
            SOFTWARE_REVISION_0,
            SOFTWARE_REVISION_1,
            SOFTWARE_REVISION_2,
            SOFTWARE_REVISION_3,
            REV_COUNTER,
            PROFILE_ID_HIBYTE,
            PROFILE_ID_LOBYTE,
            PROFILE_SPECIFIC_TYPE,
            IM_VERSION,
            IM_SUPPORTED
        }
	}
}


COMMAND commandREAD_IM1
{
	SLOT 0;
	INDEX 255;
	OPERATION READ;
	TRANSACTION
	{
        REQUEST
        {
        }
        REPLY
        {
			0x08, 0x00,
			0xFD, 0xE9,	// IM_INDEX 65001

      MANUFACTURER_SPECIFIC_IM1,
			TAG_FUNCTION,
			TAG_LOCATION
        }
	}
}


COMMAND commandWRITE_IM1
{
	SLOT 0;
	INDEX 255;
	OPERATION WRITE;
	TRANSACTION
	{
        REQUEST
        {
			0x08, 0x00,
			0xFD, 0xE9,	// IM_INDEX 65001

            MANUFACTURER_SPECIFIC_IM1,
			TAG_FUNCTION,
			TAG_LOCATION
        }
        REPLY
        {
        }
	}
}


COMMAND commandREAD_IM2
{
	SLOT 0;
	INDEX 255;
	OPERATION READ;
	TRANSACTION
	{
        REQUEST
        {
        }
        REPLY
        {
			0x08, 0x00,
			0xFD, 0xEA,	// IM_INDEX 65002

            MANUFACTURER_SPECIFIC_IM2
			INSTALLATION_DATE,
			TAG_LOCATION
        }
	}
}

COMMAND commandWRITE_IM2
{
	SLOT 0;
	INDEX 255;
	OPERATION WRITE;
	TRANSACTION
	{
        REQUEST
        {
			0x08, 0x00,
			0xFD, 0xEA,	// IM_INDEX 65002

            MANUFACTURER_SPECIFIC_IM2
			INSTALLATION_DATE,
			TAG_LOCATION
        }
        REPLY
        {
        }
	}
}


COMMAND commandREAD_IM3
{
	SLOT 0;
	INDEX 255;
	OPERATION READ;
	TRANSACTION
	{
        REQUEST
        {
        }
        REPLY
        {
			0x08, 0x00,
			0xFD, 0xEB,	// IM_INDEX 65003

            MANUFACTURER_SPECIFIC_IM3,
			DESCRIPTOR
        }
	}
}

COMMAND commandWRITE_IM3
{
	SLOT 0;
	INDEX 255;
	OPERATION WRITE;
	TRANSACTION
	{
        REQUEST
        {
			0x08, 0x00,
			0xFD, 0xEB,	// IM_INDEX 65003

            MANUFACTURER_SPECIFIC_IM3,
			DESCRIPTOR
        }
        REPLY
        {
        }
	}
}


COMMAND commandREAD_IM4
{
	SLOT 0;
	INDEX 255;
	OPERATION READ;
	TRANSACTION
	{
        REQUEST
        {
        }
        REPLY
        {
			0x08, 0x00,
			0xFD, 0xEC,	// IM_INDEX 65004

            MANUFACTURER_SPECIFIC_IM4,
			SIGNATURE
        }
	}
}


COMMAND commandWRITE_IM4
{
	SLOT 0;
	INDEX 255;
	OPERATION READ;
	TRANSACTION
	{
        REQUEST
        {
			0x08, 0x00,
			0xFD, 0xEC,	// IM_INDEX 65004

            MANUFACTURER_SPECIFIC_IM4,
			SIGNATURE
        }
        REPLY
        {
        }
	}
}


/*******************************************************************************/
/*****	Methods		************************************************************/
/*******************************************************************************/

METHOD methodUpdate_SOFTWARE_REVISION
{
	LABEL "methodUpdate_SOFTWARE_REVISION";
	DEFINITION
	{
		char strSoftware_Revision[];

		strSoftware_Revision = SOFTWARE_REVISION_0;
		strSoftware_Revision += SOFTWARE_REVISION_1;
		strSoftware_Revision += ".";
		strSoftware_Revision += SOFTWARE_REVISION_2;
		strSoftware_Revision += ".";
		strSoftware_Revision += SOFTWARE_REVISION_3;

		SOFTWARE_REVISION = strSoftware_Revision;
		SOFTWARE_REVISION.VARIABLE_STATUS = SOFTWARE_REVISION_0.VARIABLE_STATUS;
	}
}

METHOD methodPRE_READ_IM0
{
	LABEL "methodPRE_READ_IM0";
	DEFINITION
	{
		IM_INDEX = 65000;
		WriteCommand(commandPRE_READ_IM);
	}
}


METHOD methodPRE_READ_IM1
{
	LABEL "methodPRE_READ_IM1";
	DEFINITION
	{
		IM_INDEX = 65001;
		WriteCommand(commandPRE_READ_IM);
	}
}



METHOD methodPRE_READ_IM2
{
	LABEL "methodPRE_READ_IM2";
	DEFINITION
	{
		IM_INDEX = 65002;
		WriteCommand(commandPRE_READ_IM);
	}
}


METHOD methodPRE_READ_IM3
{
	LABEL "methodPRE_READ_IM3";
	DEFINITION
	{
		IM_INDEX = 65003;
		WriteCommand(commandPRE_READ_IM);
	}
}


METHOD methodPRE_READ_IM4
{
	LABEL "methodPRE_READ_IM4";
	DEFINITION
	{
		IM_INDEX = 65004;
		WriteCommand(commandPRE_READ_IM);
	}
}
