/*===================================================================
 File name:	    T_6680_0A8A_relais.inc
 Date:      	  Aug. 21. 2006
---------------------------------------------------------------------
 DESCRIPTION:
 Device Configuration Menu for Relays
                                      
 DEVICE:
 T6680 Humidity Device 
---------------------------------------------------------------------
 Revision history:
 REV 0.01 DATE:210806	 TMG/WZ first release

===================================================================*/


/**************************************************/
/******************* Macros ***********************/
/**************************************************/

/**************************************************/
/*************** Windows and dialogs **************/
/**************************************************/


//MENU relais_menu
//{
//	LABEL		[relais_menu];
//	HELP		[relais_menu];
//	ACCESS      OFFLINE;
//	ITEMS
//	{
//    method_get_relais_status,
////		"Button: wie ist das aktuelle Relais-Setting => lese Alarm_lim_n",
////		"Wenn Control-Byte 0 oder 5 oder 6, dann erlaube Realiszuordnung zu Alarmen",
////		"andernfalls graue die Eingabe-Mglichkeit"
////		trans2_hm_alarm_lim_relay_1,
//		RELAIS_1,
//		RELAIS_2,
//		RELAIS_3,
//		RELAIS_4,
//		SEPARATOR,
//		method_set_relais_status,
//		SEPARATOR,
//		trans2_hm_alarm_lim_relay_1, 
//		trans2_hm_alarm_lim_relay_2,
//		trans2_hm_alarm_lim_relay_3,
//		trans2_hm_alarm_lim_relay_4,
//		method_reset_relais_status
//	}
//}


MENU relais_menu_s // Specialist
{
	LABEL   [relais_menu];
	ITEMS
	{
		method_get_relais_status,
		SEPARATOR,
		Group_method_set_relais_status_s,
		Group_method_reset_relais_status_s
 	}
}

MENU relais_menu_m // Maintenance Engineer
{
	LABEL   [relais_menu];
	ITEMS
	{
		method_get_relais_status,
		SEPARATOR,
		Group_method_set_relais_status_m
//		,
//		Group_method_reset_relais_status_s
 	}
}

MENU Group_method_set_relais_status_s
{
  LABEL		[set_relais_status];
  STYLE   GROUP;
	ACCESS      OFFLINE;
	ITEMS
	{
		RELAIS_1,
		RELAIS_2,
		RELAIS_3,
		RELAIS_4,
		SEPARATOR,
		method_set_relais_status
  }
}

MENU Group_method_set_relais_status_m
{
  LABEL		[set_relais_status];
  STYLE   GROUP;
	ACCESS      OFFLINE;
	ITEMS
	{
		RELAIS_1 (READ_ONLY),
		RELAIS_2 (READ_ONLY),
		RELAIS_3 (READ_ONLY),
		RELAIS_4 (READ_ONLY)
//		,
//		SEPARATOR,
//		method_set_relais_status
  }
}

MENU Group_method_reset_relais_status_s
{
  LABEL		[reset_relais_status];
  STYLE   GROUP;
	ACCESS      OFFLINE;
	ITEMS
	{
		method_reset_relais_status
  }
}


/**************************************************/
/****************** Variables *********************/
/**************************************************/



VARIABLE RELAIS_1
{
	LABEL [RELAIS_1];
	CLASS CONTAINED;
	TYPE ENUMERATED (2)
	{
		DEFAULT_VALUE 
		IF ((trans2_hm_alarm_lim_relay_1 & 0xff00)==0x0000)
		{
			0;
		}
		IF ((trans2_hm_alarm_lim_relay_1 & 0xff00)==0x0500)
		{
			0;
		}
		IF ((trans2_hm_alarm_lim_relay_1 & 0xff00)>0x0000)
		{
		   IF ((trans2_hm_alarm_lim_relay_1 & 0xff00)<0x0500)
		   {
		   	9;
		   }
		}
  IF ((trans2_hm_alarm_lim_relay_1 & 0xff00)==0x0000) 
	  {	  	
		   {0, [_not_used]},
		   {1, [LO_LO_Channel_1]},
		   {2, [LO_Channel_1]},
		   {3, [HI_Channel_1]},
		   {4, [HI_HI_Channel_1]},
		   {5, [LO_LO_Channel_2]},
		   {6, [LO_Channel_2]},
		   {7, [HI_Channel_2]},
		   {8, [HI_HI_Channel_2]}
		}
		IF ((trans2_hm_alarm_lim_relay_1 & 0xff00)==0x0500)
		{	  	
		   {0, [_not_used]},
		   {1, [LO_LO_Channel_1]},
		   {2, [LO_Channel_1]},
		   {3, [HI_Channel_1]},
		   {4, [HI_HI_Channel_1]},
		   {5, [LO_LO_Channel_2]},
		   {6, [LO_Channel_2]},
		   {7, [HI_Channel_2]},
		   {8, [HI_HI_Channel_2]}
		}
		IF ((trans2_hm_alarm_lim_relay_1 & 0xff00)>0x0000)
		{
		   IF ((trans2_hm_alarm_lim_relay_1 & 0xff00)<0x0500)
		   {
		   	{9, [Muf_controlled]}
		   }
		}
	 }

	HANDLING READ & WRITE;
}

VARIABLE RELAIS_2
{
	LABEL [RELAIS_2];
	CLASS CONTAINED;
	TYPE ENUMERATED (2)
	{
		DEFAULT_VALUE 
		IF ((trans2_hm_alarm_lim_relay_2 & 0xff00)==0x0000)
		{
			0;
		}
		IF ((trans2_hm_alarm_lim_relay_2 & 0xff00)==0x0500)
		{
			0;
		}
		IF ((trans2_hm_alarm_lim_relay_2 & 0xff00)>0x0000)
		{
		   IF ((trans2_hm_alarm_lim_relay_2 & 0xff00)<0x0500)
		   {
		   	9;
		   }
		}
	  IF ((trans2_hm_alarm_lim_relay_2 & 0xff00)==0x0000) 
	  {	  	
		   {0, [_not_used]},
		   {1, [LO_LO_Channel_1]},
		   {2, [LO_Channel_1]},
		   {3, [HI_Channel_1]},
		   {4, [HI_HI_Channel_1]},
		   {5, [LO_LO_Channel_2]},
		   {6, [LO_Channel_2]},
		   {7, [HI_Channel_2]},
		   {8, [HI_HI_Channel_2]}
		}
		IF ((trans2_hm_alarm_lim_relay_2 & 0xff00)==0x0500)
		{	  	
		   {0, [_not_used]},
		   {1, [LO_LO_Channel_1]},
		   {2, [LO_Channel_1]},
		   {3, [HI_Channel_1]},
		   {4, [HI_HI_Channel_1]},
		   {5, [LO_LO_Channel_2]},
		   {6, [LO_Channel_2]},
		   {7, [HI_Channel_2]},
		   {8, [HI_HI_Channel_2]}
		}
		IF ((trans2_hm_alarm_lim_relay_2 & 0xff00)>0x0000)
		{
		   IF ((trans2_hm_alarm_lim_relay_2 & 0xff00)<0x0500)
		   {
		   	{9, [Muf_controlled]}
		   }
		}
	}
	HANDLING READ & WRITE;
}

VARIABLE RELAIS_3
{
	LABEL [RELAIS_3];
	CLASS CONTAINED;
	TYPE ENUMERATED (2)
	{
		DEFAULT_VALUE 
		IF ((trans2_hm_alarm_lim_relay_3 & 0xff00)==0x0000)
		{
			0;
		}
		IF ((trans2_hm_alarm_lim_relay_3 & 0xff00)==0x0500)
		{
			0;
		}
		IF ((trans2_hm_alarm_lim_relay_3 & 0xff00)>0x0000)
		{
		   IF ((trans2_hm_alarm_lim_relay_3 & 0xff00)<0x0500)
		   {
		   	9;
		   }
		}
	  IF ((trans2_hm_alarm_lim_relay_3 & 0xff00)==0x0000) 
	  {	  	
		   {0, [_not_used]},
		   {1, [LO_LO_Channel_1]},
		   {2, [LO_Channel_1]},
		   {3, [HI_Channel_1]},
		   {4, [HI_HI_Channel_1]},
		   {5, [LO_LO_Channel_2]},
		   {6, [LO_Channel_2]},
		   {7, [HI_Channel_2]},
		   {8, [HI_HI_Channel_2]}
		}
		IF ((trans2_hm_alarm_lim_relay_3 & 0xff00)==0x0500)
		{	  	
		   {0, [_not_used]},
		   {1, [LO_LO_Channel_1]},
		   {2, [LO_Channel_1]},
		   {3, [HI_Channel_1]},
		   {4, [HI_HI_Channel_1]},
		   {5, [LO_LO_Channel_2]},
		   {6, [LO_Channel_2]},
		   {7, [HI_Channel_2]},
		   {8, [HI_HI_Channel_2]}
		}
		IF ((trans2_hm_alarm_lim_relay_3 & 0xff00)>0x0000)
		{
		   IF ((trans2_hm_alarm_lim_relay_3 & 0xff00)<0x0500)
		   {
		   	{9, [Muf_controlled]}
		   }
		}
	 }
	HANDLING READ & WRITE;
}

VARIABLE RELAIS_4
{
	LABEL [RELAIS_4];
	CLASS CONTAINED;
	TYPE ENUMERATED (2)
	{
		DEFAULT_VALUE 
		IF ((trans2_hm_alarm_lim_relay_4 & 0xff00)==0x0000)
		{
			0;
		}
		IF ((trans2_hm_alarm_lim_relay_4 & 0xff00)==0x0500)
		{
			0;
		}
		IF ((trans2_hm_alarm_lim_relay_4 & 0xff00)>0x0000)
		{
		   IF ((trans2_hm_alarm_lim_relay_4 & 0xff00)<0x0500)
		   {
		   	9;
		   }
		}
	  IF ((trans2_hm_alarm_lim_relay_4 & 0xff00)==0x0000) 
	  {	  	
		   {0, [_not_used]},
		   {1, [LO_LO_Channel_1]},
		   {2, [LO_Channel_1]},
		   {3, [HI_Channel_1]},
		   {4, [HI_HI_Channel_1]},
		   {5, [LO_LO_Channel_2]},
		   {6, [LO_Channel_2]},
		   {7, [HI_Channel_2]},
		   {8, [HI_HI_Channel_2]}
		}
		IF ((trans2_hm_alarm_lim_relay_4 & 0xff00)==0x0500)
		{	  	
		   {0, [_not_used]},
		   {1, [LO_LO_Channel_1]},
		   {2, [LO_Channel_1]},
		   {3, [HI_Channel_1]},
		   {4, [HI_HI_Channel_1]},
		   {5, [LO_LO_Channel_2]},
		   {6, [LO_Channel_2]},
		   {7, [HI_Channel_2]},
		   {8, [HI_HI_Channel_2]}
		}
		IF ((trans2_hm_alarm_lim_relay_4 & 0xff00)>0x0000)
		{
		   IF ((trans2_hm_alarm_lim_relay_4 & 0xff00)<0x0500)
		   {
		   	{9, [Muf_controlled]}
		   }
		}
	 }
	HANDLING READ & WRITE;
}


/**************************************************/
/********************  Methods  *******************/
/**************************************************/

METHOD method_get_relais_status 
{
	LABEL		[get_relais_status];
	DEFINITION
	{
		ReadCommand (read_trans2_hm_alarm_lim_relay_1);
		ReadCommand (read_trans2_hm_alarm_lim_relay_2);
		ReadCommand (read_trans2_hm_alarm_lim_relay_3);
		ReadCommand (read_trans2_hm_alarm_lim_relay_4);
		if ((trans2_hm_alarm_lim_relay_1 & 0xff00) == 0x0500)
    {
    	if ((trans2_hm_alarm_lim_relay_1 & 0x00ff) == 0x0000)
    	{
    		RELAIS_1 = 0;
    	}
    	if ((trans2_hm_alarm_lim_relay_1 & 0x00ff) == 0x0001)
    	{
    		RELAIS_1 = 1;
    	}
    	if ((trans2_hm_alarm_lim_relay_1 & 0x00ff) == 0x0002)
    	{
    		RELAIS_1 = 2;
    	}
    	if ((trans2_hm_alarm_lim_relay_1 & 0x00ff) == 0x0003)
    	{
    		RELAIS_1 = 3;
    	}
    	if ((trans2_hm_alarm_lim_relay_1 & 0x00ff) == 0x0004)
    	{
    		RELAIS_1 = 4;
    	}
    	if ((trans2_hm_alarm_lim_relay_1 & 0x00ff) == 0x0005)
    	{
    		RELAIS_1 = 5;
    	}
    	if ((trans2_hm_alarm_lim_relay_1 & 0x00ff) == 0x0006)
    	{
    		RELAIS_1 = 6;
    	}
    	if ((trans2_hm_alarm_lim_relay_1 & 0x00ff) == 0x0007)
    	{
    		RELAIS_1 = 7;
    	}
    	if ((trans2_hm_alarm_lim_relay_1 & 0x00ff) == 0x0008)
    	{
    		RELAIS_1 = 8;
    	}
    }
    if ((trans2_hm_alarm_lim_relay_1 & 0xff00) == 0x0000)
    {
    	if ((trans2_hm_alarm_lim_relay_1 & 0x00ff) == 0x0000)
    	{
    		RELAIS_1 = 0;
    	}
    }
    if ((trans2_hm_alarm_lim_relay_1 & 0xff00) > 0x0000) 
    {
    	if ((trans2_hm_alarm_lim_relay_1 & 0xff00) < 0x0500)
    	{
    		RELAIS_1 = 9;
    	}
    }

		if ((trans2_hm_alarm_lim_relay_2 & 0xff00) == 0x0500)
    {
    	if ((trans2_hm_alarm_lim_relay_2 & 0x00ff) == 0x0000)
    	{
    		RELAIS_2 = 0;
    	}
    	if ((trans2_hm_alarm_lim_relay_2 & 0x00ff) == 0x0001)
    	{
    		RELAIS_2 = 1;
    	}
    	if ((trans2_hm_alarm_lim_relay_2 & 0x00ff) == 0x0002)
    	{
    		RELAIS_2 = 2;
    	}
    	if ((trans2_hm_alarm_lim_relay_2 & 0x00ff) == 0x0003)
    	{
    		RELAIS_2 = 3;
    	}
    	if ((trans2_hm_alarm_lim_relay_2 & 0x00ff) == 0x0004)
    	{
    		RELAIS_2 = 4;
    	}
    	if ((trans2_hm_alarm_lim_relay_2 & 0x00ff) == 0x0005)
    	{
    		RELAIS_2 = 5;
    	}
    	if ((trans2_hm_alarm_lim_relay_2 & 0x00ff) == 0x0006)
    	{
    		RELAIS_2 = 6;
    	}
    	if ((trans2_hm_alarm_lim_relay_2 & 0x00ff) == 0x0007)
    	{
    		RELAIS_2 = 7;
    	}
    	if ((trans2_hm_alarm_lim_relay_2 & 0x00ff) == 0x0008)
    	{
    		RELAIS_2 = 8;
    	}
    }
    if ((trans2_hm_alarm_lim_relay_2 & 0xff00) == 0x0000)
    {
    	if ((trans2_hm_alarm_lim_relay_2 & 0x00ff) == 0x0000)
    	{
    		RELAIS_2 = 0;
    	}
    }
    if (((trans2_hm_alarm_lim_relay_2 & 0xff00) != 0x0000) & ((trans2_hm_alarm_lim_relay_2 & 0xff00) != 0x0500))
    {
    	RELAIS_2 = 9;
    }

		if ((trans2_hm_alarm_lim_relay_3 & 0xff00) == 0x0500)
    {
    	if ((trans2_hm_alarm_lim_relay_3 & 0x00ff) == 0x0000)
    	{
    		RELAIS_3 = 0;
    	}
    	if ((trans2_hm_alarm_lim_relay_3 & 0x00ff) == 0x0001)
    	{
    		RELAIS_3 = 1;
    	}
    	if ((trans2_hm_alarm_lim_relay_3 & 0x00ff) == 0x0002)
    	{
    		RELAIS_3 = 2;
    	}
    	if ((trans2_hm_alarm_lim_relay_3 & 0x00ff) == 0x0003)
    	{
    		RELAIS_3 = 3;
    	}
    	if ((trans2_hm_alarm_lim_relay_3 & 0x00ff) == 0x0004)
    	{
    		RELAIS_3 = 4;
    	}
    	if ((trans2_hm_alarm_lim_relay_3 & 0x00ff) == 0x0005)
    	{
    		RELAIS_3 = 5;
    	}
    	if ((trans2_hm_alarm_lim_relay_3 & 0x00ff) == 0x0006)
    	{
    		RELAIS_3 = 6;
    	}
    	if ((trans2_hm_alarm_lim_relay_3 & 0x00ff) == 0x0007)
    	{
    		RELAIS_3 = 7;
    	}
    	if ((trans2_hm_alarm_lim_relay_3 & 0x00ff) == 0x0008)
    	{
    		RELAIS_3 = 8;
    	}
    }
    if ((trans2_hm_alarm_lim_relay_3 & 0xff00) == 0x0000)
    {
    	if ((trans2_hm_alarm_lim_relay_3 & 0x00ff) == 0x0000)
    	{
    		RELAIS_3 = 0;
    	}
    }
    if (((trans2_hm_alarm_lim_relay_3 & 0xff00) != 0x0000) & ((trans2_hm_alarm_lim_relay_3 & 0xff00) != 0x0500))
    {
    	RELAIS_3 = 9;
    }

		if ((trans2_hm_alarm_lim_relay_4 & 0xff00) == 0x0500)
    {
    	if ((trans2_hm_alarm_lim_relay_4 & 0x00ff) == 0x0000)
    	{
    		RELAIS_4 = 0;
    	}
    	if ((trans2_hm_alarm_lim_relay_4 & 0x00ff) == 0x0001)
    	{
    		RELAIS_4 = 1;
    	}
    	if ((trans2_hm_alarm_lim_relay_4 & 0x00ff) == 0x0002)
    	{
    		RELAIS_4 = 2;
    	}
    	if ((trans2_hm_alarm_lim_relay_4 & 0x00ff) == 0x0003)
    	{
    		RELAIS_4 = 3;
    	}
    	if ((trans2_hm_alarm_lim_relay_4 & 0x00ff) == 0x0004)
    	{
    		RELAIS_4 = 4;
    	}
    	if ((trans2_hm_alarm_lim_relay_4 & 0x00ff) == 0x0005)
    	{
    		RELAIS_4 = 5;
    	}
    	if ((trans2_hm_alarm_lim_relay_4 & 0x00ff) == 0x0006)
    	{
    		RELAIS_4 = 6;
    	}
    	if ((trans2_hm_alarm_lim_relay_4 & 0x00ff) == 0x0007)
    	{
    		RELAIS_4 = 7;
    	}
    	if ((trans2_hm_alarm_lim_relay_4 & 0x00ff) == 0x0008)
    	{
    		RELAIS_4 = 8;
    	}
    }
    if ((trans2_hm_alarm_lim_relay_4 & 0xff00) == 0x0000)
    {
    	if ((trans2_hm_alarm_lim_relay_4 & 0x00ff) == 0x0000)
    	{
    		RELAIS_4 = 0;
    	}
    }
    if (((trans2_hm_alarm_lim_relay_4 & 0xff00) != 0x0000) & ((trans2_hm_alarm_lim_relay_4 & 0xff00) != 0x0500))
    {
    	RELAIS_4 = 9;
    }
   }
}

METHOD method_set_relais_status 
{
	LABEL		[set_relais_status];
	DEFINITION
	{
		ReadCommand (read_trans2_hm_alarm_lim_relay_1);
		ReadCommand (read_trans2_hm_alarm_lim_relay_2);
		ReadCommand (read_trans2_hm_alarm_lim_relay_3);
		ReadCommand (read_trans2_hm_alarm_lim_relay_4);
/*Relais 1, unbelegt vom MUF und PROFIBUS */
    if ((trans2_hm_alarm_lim_relay_1 & 0xff00) == 0x0000)
    {
	   if (RELAIS_1==0)
     {
    	trans2_hm_alarm_lim_relay_1 = 0x0500;
     }
	   if (RELAIS_1==1)
     {
   		trans2_hm_alarm_lim_relay_1 = 0x0501;
   	 }
	   if (RELAIS_1==2)
     {
    	trans2_hm_alarm_lim_relay_1 = 0x0502;
     }
	   if (RELAIS_1==3)
     {
    	trans2_hm_alarm_lim_relay_1 = 0x0503;
     }
	   if (RELAIS_1==4)
     {
    	trans2_hm_alarm_lim_relay_1 = 0x0504;
     }
	   if (RELAIS_1==5)
     {
    	trans2_hm_alarm_lim_relay_1 = 0x0505;
     }
	   if (RELAIS_1==6)
     {
    	trans2_hm_alarm_lim_relay_1 = 0x0506;
     }
	   if (RELAIS_1==7)
     {
    	trans2_hm_alarm_lim_relay_1 = 0x0507;
     }
	   if (RELAIS_1==8)
     {
    	trans2_hm_alarm_lim_relay_1 = 0x0508;
     }
    }
/*Relais 1, PROFIBUS zugeordnet*/   
    if ((trans2_hm_alarm_lim_relay_1 & 0xff00) == 0x0500)
    {
	   if (RELAIS_1==0)
     {
    	trans2_hm_alarm_lim_relay_1 = 0x0500;
     }
	   if (RELAIS_1==1)
     {
   		trans2_hm_alarm_lim_relay_1 = 0x0501;
   	 }
	   if (RELAIS_1==2)
     {
    	trans2_hm_alarm_lim_relay_1 = 0x0502;
     }
	   if (RELAIS_1==3)
     {
    	trans2_hm_alarm_lim_relay_1 = 0x0503;
     }
	   if (RELAIS_1==4)
     {
    	trans2_hm_alarm_lim_relay_1 = 0x0504;
     }
	   if (RELAIS_1==5)
     {
    	trans2_hm_alarm_lim_relay_1 = 0x0505;
     }
	   if (RELAIS_1==6)
     {
    	trans2_hm_alarm_lim_relay_1 = 0x0506;
     }
	   if (RELAIS_1==7)
     {
    	trans2_hm_alarm_lim_relay_1 = 0x0507;
     }
	   if (RELAIS_1==8)
     {
    	trans2_hm_alarm_lim_relay_1 = 0x0508;
     }
    }
/*Relais 2, unbelegt vom MUF und PROFIBUS */
    if ((trans2_hm_alarm_lim_relay_2 & 0xff00) == 0x0000)
    {
	   if (RELAIS_2==0)
     {
    	trans2_hm_alarm_lim_relay_2 = 0x0500;
     }
	   if (RELAIS_2==1)
     {
   		trans2_hm_alarm_lim_relay_2 = 0x0501;
   	 }
	   if (RELAIS_2==2)
     {
    	trans2_hm_alarm_lim_relay_2 = 0x0502;
     }
	   if (RELAIS_2==3)
     {
    	trans2_hm_alarm_lim_relay_2 = 0x0503;
     }
	   if (RELAIS_2==4)
     {
    	trans2_hm_alarm_lim_relay_2 = 0x0504;
     }
	   if (RELAIS_2==5)
     {
    	trans2_hm_alarm_lim_relay_2 = 0x0505;
     }
	   if (RELAIS_2==6)
     {
    	trans2_hm_alarm_lim_relay_2 = 0x0506;
     }
	   if (RELAIS_2==7)
     {
    	trans2_hm_alarm_lim_relay_2 = 0x0507;
     }
	   if (RELAIS_2==8)
     {
    	trans2_hm_alarm_lim_relay_2 = 0x0508;
     }
    }
/*Relais 2, PROFIBUS zugeordnet*/
    if ((trans2_hm_alarm_lim_relay_2 & 0xff00) == 0x0500)
    {
	   if (RELAIS_2==0)
     {
    	trans2_hm_alarm_lim_relay_2 = 0x0500;
     }
	   if (RELAIS_2==1)
     {
   		trans2_hm_alarm_lim_relay_2 = 0x0501;
   	 }
	   if (RELAIS_2==2)
     {
    	trans2_hm_alarm_lim_relay_2 = 0x0502;
     }
	   if (RELAIS_2==3)
     {
    	trans2_hm_alarm_lim_relay_2 = 0x0503;
     }
	   if (RELAIS_2==4)
     {
    	trans2_hm_alarm_lim_relay_2 = 0x0504;
     }
	   if (RELAIS_2==5)
     {
    	trans2_hm_alarm_lim_relay_2 = 0x0505;
     }
	   if (RELAIS_2==6)
     {
    	trans2_hm_alarm_lim_relay_2 = 0x0506;
     }
	   if (RELAIS_2==7)
     {
    	trans2_hm_alarm_lim_relay_2 = 0x0507;
     }
	   if (RELAIS_2==8)
     {
    	trans2_hm_alarm_lim_relay_2 = 0x0508;
     }
    }
/*Relais 3, unbelegt vom MUF und PROFIBUS */
    if ((trans2_hm_alarm_lim_relay_3 & 0xff00) == 0x0000)
    {
	   if (RELAIS_3==0)
     {
    	trans2_hm_alarm_lim_relay_3 = 0x0500;
     }
	   if (RELAIS_3==1)
     {
   		trans2_hm_alarm_lim_relay_3 = 0x0501;
   	 }
	   if (RELAIS_3==2)
     {
    	trans2_hm_alarm_lim_relay_3 = 0x0502;
     }
	   if (RELAIS_3==3)
     {
    	trans2_hm_alarm_lim_relay_3 = 0x0503;
     }
	   if (RELAIS_3==4)
     {
    	trans2_hm_alarm_lim_relay_3 = 0x0504;
     }
	   if (RELAIS_3==5)
     {
    	trans2_hm_alarm_lim_relay_3 = 0x0505;
     }
	   if (RELAIS_3==6)
     {
    	trans2_hm_alarm_lim_relay_3 = 0x0506;
     }
	   if (RELAIS_3==7)
     {
    	trans2_hm_alarm_lim_relay_3 = 0x0507;
     }
	   if (RELAIS_3==8)
     {
    	trans2_hm_alarm_lim_relay_3 = 0x0508;
     }
    }
/*Relais 3, PROFIBUS zugeordnet */
    if ((trans2_hm_alarm_lim_relay_3 & 0xff00) == 0x0500)
    {
	   if (RELAIS_3==0)
     {
    	trans2_hm_alarm_lim_relay_3 = 0x0500;
     }
	   if (RELAIS_3==1)
     {
   		trans2_hm_alarm_lim_relay_3 = 0x0501;
   	 }
	   if (RELAIS_3==2)
     {
    	trans2_hm_alarm_lim_relay_3 = 0x0502;
     }
	   if (RELAIS_3==3)
     {
    	trans2_hm_alarm_lim_relay_3 = 0x0503;
     }
	   if (RELAIS_3==4)
     {
    	trans2_hm_alarm_lim_relay_3 = 0x0504;
     }
	   if (RELAIS_3==5)
     {
    	trans2_hm_alarm_lim_relay_3 = 0x0505;
     }
	   if (RELAIS_3==6)
     {
    	trans2_hm_alarm_lim_relay_3 = 0x0506;
     }
	   if (RELAIS_3==7)
     {
    	trans2_hm_alarm_lim_relay_3 = 0x0507;
     }
	   if (RELAIS_3==8)
     {
    	trans2_hm_alarm_lim_relay_3 = 0x0508;
     }
    }
/*Relais 4, unbelegt vom MUF und PROFIBUS */
    if ((trans2_hm_alarm_lim_relay_4 & 0xff00) == 0x0000)
    {
	   if (RELAIS_4==0)
     {
    	trans2_hm_alarm_lim_relay_4 = 0x0500;
     }
	   if (RELAIS_4==1)
     {
   		trans2_hm_alarm_lim_relay_4 = 0x0501;
   	 }
	   if (RELAIS_4==2)
     {
    	trans2_hm_alarm_lim_relay_4 = 0x0502;
     }
	   if (RELAIS_4==3)
     {
    	trans2_hm_alarm_lim_relay_4 = 0x0503;
     }
	   if (RELAIS_4==4)
     {
    	trans2_hm_alarm_lim_relay_4 = 0x0504;
     }
	   if (RELAIS_4==5)
     {
    	trans2_hm_alarm_lim_relay_4 = 0x0505;
     }
	   if (RELAIS_4==6)
     {
    	trans2_hm_alarm_lim_relay_4 = 0x0506;
     }
	   if (RELAIS_4==7)
     {
    	trans2_hm_alarm_lim_relay_4 = 0x0507;
     }
	   if (RELAIS_4==8)
     {
    	trans2_hm_alarm_lim_relay_4 = 0x0508;
     }
    }
/*Relais 4, PROFIBUS zugeordnet */
    if ((trans2_hm_alarm_lim_relay_4 & 0xff00) == 0x0500)
    {
	   if (RELAIS_4==0)
     {
    	trans2_hm_alarm_lim_relay_4 = 0x0500;
     }
	   if (RELAIS_4==1)
     {
   		trans2_hm_alarm_lim_relay_4 = 0x0501;
   	 }
	   if (RELAIS_4==2)
     {
    	trans2_hm_alarm_lim_relay_4 = 0x0502;
     }
	   if (RELAIS_4==3)
     {
    	trans2_hm_alarm_lim_relay_4 = 0x0503;
     }
	   if (RELAIS_4==4)
     {
    	trans2_hm_alarm_lim_relay_4 = 0x0504;
     }
	   if (RELAIS_4==5)
     {
    	trans2_hm_alarm_lim_relay_4 = 0x0505;
     }
	   if (RELAIS_4==6)
     {
    	trans2_hm_alarm_lim_relay_4 = 0x0506;
     }
	   if (RELAIS_4==7)
     {
    	trans2_hm_alarm_lim_relay_4 = 0x0507;
     }
	   if (RELAIS_4==8)
     {
    	trans2_hm_alarm_lim_relay_4 = 0x0508;
     }
    }
		WriteCommand (write_trans2_hm_alarm_lim_relay_1);
		WriteCommand (write_trans2_hm_alarm_lim_relay_2);
		WriteCommand (write_trans2_hm_alarm_lim_relay_3);
		WriteCommand (write_trans2_hm_alarm_lim_relay_4);
	}
}

METHOD method_reset_relais_status 
{
	LABEL		[reset_relais_status];
	DEFINITION
	{
		ReadCommand (read_trans2_hm_alarm_lim_relay_1);
		ReadCommand (read_trans2_hm_alarm_lim_relay_2);
		ReadCommand (read_trans2_hm_alarm_lim_relay_3);
		ReadCommand (read_trans2_hm_alarm_lim_relay_4);
		if ((trans2_hm_alarm_lim_relay_1 & 0xff00)==0x0500)
		{
			trans2_hm_alarm_lim_relay_1 = 0;
		}
		if ((trans2_hm_alarm_lim_relay_2 & 0xff00)==0x0500)
		{
			trans2_hm_alarm_lim_relay_2 = 0;
		}
		if ((trans2_hm_alarm_lim_relay_3 & 0xff00)==0x0500)
		{
			trans2_hm_alarm_lim_relay_3 = 0;
		}
		if ((trans2_hm_alarm_lim_relay_4 & 0xff00)==0x0500)
		{
			trans2_hm_alarm_lim_relay_4 = 0;
		}
		WriteCommand (write_trans2_hm_alarm_lim_relay_1);
		WriteCommand (write_trans2_hm_alarm_lim_relay_2);
		WriteCommand (write_trans2_hm_alarm_lim_relay_3);
		WriteCommand (write_trans2_hm_alarm_lim_relay_4);

	}
}





