/*===================================================================
 File name:	    T_6680_0A8A_PB.inc
 Date:      	  Aug. 21. 2006
---------------------------------------------------------------------
 DESCRIPTION:
 Physical Block Variables

 DEVICE:
 T6680 Humidity Device
---------------------------------------------------------------------
 Revision history:
 REV 0.01 DATE:210806	 TMG/WZ first release

===================================================================*/



//#include "Manufacturer_List.h"

#define MANUFACTURER_LIST						\
	    { 1,   [Acromag] },						\
	    { 2,   [Allen_Bradley] },					\
	    { 3,   [Ametek] },						\
	    { 4,   [Analog_Devices] },				\
	    { 5,   [Elsag_Bailey] },					\
	    { 6,   [Beckman] },						\
	    { 7,   [Bell_Microsensor] },				\
	    { 8,   [Bourns] },						\
	    { 9,   [Bristol_Babcock] },				\
	    { 10,  [Brooks_Instrument] },				\
	    { 11,  [Chessell] },						\
	    { 12,  [Combustion_Engineering] },		\
	    { 13,  [Daniel_Industries] },				\
	    { 14,  [Delta] },							\
	    { 15,  [Dieterich_Standard] },			\
	    { 16,  [Dohrmann] },						\
	    { 17,  [Endress_and_Hauser] },			\
	    { 18,  [Elsag_Bailey] },					\
	    { 19,  [Fisher_Controls] },				\
	    { 20,  [Foxboro] },						\
	    { 21,  [Fuji] },							\
	    { 22,  [Elsag_Bailey] },					\
	    { 23,  [Honeywell] },						\
	    { 24,  [ITT_Barton] },					\
	    { 25,  [KayRay_Sensall] },				\
	    { 26,  [ABB] },							\
	    { 27,  [Leeds_and_Northrup] },			\
	    { 28,  [Leslie] },						\
	    { 29,  [M_System_Co] },					\
	    { 30,  [Measurex] },						\
	    { 31,  [Micro_Motion] },					\
	    { 32,  [Moore_Industries] },				\
	    { 33,  [Moore_Products] },				\
	    { 34,  [Ohkura_Electric] },				\
	    { 35,  [Paine] },							\
	    { 36,  [Rochester_Instrument_Systems] },	\
	    { 37,  [Ronan] },							\
	    { 38,  [Rosemount] },						\
	    { 39,  [Peek_Measurement] },				\
	    { 40,  [Schlumberger] },					\
	    { 41,  [Sensall] },						\
	    { 42,  [Siemens] },						\
	    { 43,  [Weed] }, /* change from Camille Bauer */			\
	    { 44,  [Toshiba] },						\
	    { 45,  [Transmation] },					\
	    { 46,  [Rosemount_Analytical] },			\
	    { 47,  [Valmet] },						\
	    { 48,  [Flowserve] },						\
	    { 49,  [Varec] },							\
	    { 50,  [Viatran] },						\
	    { 51,  [Delta_Weed] }, /* Delta/Weed */	\
	    { 52,  [Westinghouse] },					\
	    { 53,  [Xomox] },							\
	    { 54,  [Yamatake] },						\
	    { 55,  [Yokogawa] },						\
	    { 56,  [Nuovo_Pignone] },					\
	    { 57,  [Promac] },						\
	    { 58,  [Exac_Corporation] },				\
	    { 59,  [KDG_Mobrey] },					\
	    { 60,  [Acrom_Control_System] },			\
	    { 61,  [Princo] },						\
	    { 62,  [Smar] },							\
	    { 63,  [Foxboro_Eckardt] },				\
	    { 64,  [Measurement_Technology] },		\
	    { 65,  [Applied_System_Technologies] },	\
	    { 66,  [Samson] },						\
	    { 67,  [Sparling_Instruments] },			\
	    { 68,  [Fireye] },						\
	    { 69,  [Krohne] },						\
	    { 70,  [Betz_Equipment] },				\
	    { 71,  [Druck] },							\
	    { 72,  [SOR] },							\
	    { 73,  [Elcon_Instruments] },				\
	    { 74,  [EMCO] },							\
	    { 75,  [Termiflex] },						\
	    { 76,  [VAF_Instruments] },				\
	    { 77,  [Westlock_Controls] },				\
	    { 78,  [Drexelbrook] },					\
	    { 79,  [saab_tank_control] },				\
	    { 80,  [K_TEK] },							\
	    { 81,  [Flowdata] },						\
	    { 82,  [Draeger] },						\
	  { 83,  [Raytek] },						\
	  { 84,  [Meridian_Instruments] },			\
	  { 85,  [BTG] },							\
	  { 86,  [Magnetrol] },						\
	  { 87,  [Neles_Controls] },				\
	  { 88,  [Milltronics] },					\
	  { 89,  [HELIOS] },						\
	    { 90, [Anderson_Instrument_Company] },	\
	    { 91, [INOR] },							\
	    { 92, [ROBERTSHAW] },						\
	    { 93, [PEPPERL_FUCHS] },					\
	    { 94, [ACCUTECH] },						\
	    { 95, [Flow_Measurement] },				\
	    { 96, [KAMSTRUP] },						\
	    { 97, [Knick] },							\
	    { 98, [VEGA] },							\
	    { 99, [MTS_SYS_CORPS_SENSORS] },			\
	    { 100, [Oval] },							\
	    { 101, [Masoneilan_DRESSER] },			\
	    { 102, [Besta] },							\
	    { 103, [Ohmart] },						\
	    { 104, [Harold_Beck_and_Sons] },			\
	    { 105, [rittmeyer_instrumentation] },		\
	    { 106, [rossel_messtechnik] },			\
	    { 107, [WIKA] },							\
	    { 108, [Bopp_and_Reuther_Heinrichs] },	\
	    { 109, [pr_eletronics] },					\
	    { 110, [jordan_controls] },				\
	    { 111, [valcom] },						\
	    { 112, [us_electric_motors] },			\
	    { 113, [apparatebau_hundsbach] },										\
	  { 114, [Dynisco] }, /* Dynisco */										\
	  { 115, [Spriano] }, /* Spriano */										\
	  { 116, [Direct_Mesaurement] }, /* Direct Measurement */				\
	  { 117, [Klay] }, /* Klay Instruments */								\
	  { 118, [Action] }, /* Action Instruments */							\
	  { 119, [Mmg_Automatiky] }, /* MMG AM DTR - 1000 */					\
	  { 120, [Buerkert] }, /* Buerkert Fluid Control Systems */				\
	  { 121, [Hersey] }, /* Hersey Measurement */							\
	  { 122, [Pondus] }, /* PONDUS INSTRUMENTS */							\
	  { 123, [Zap] }, /* ZAP_S.A._Ostrow_Wielkopolski */					\
	  { 124, [GLI] }, /* GLI */												\
	  { 125, [FRPT] }, /* Fisher-Rosemount Performance Technologies */		\
	  { 126, [Paper_Machine_Components] }, /* Paper Machine Components */	\
	  { 127, [Labom] }, /* LABOM */											\
	  { 128, [Danfoss] }, /* Danfoss */										\
	  { 129, [Turbo] }, /* Turbo */											\
	  { 130, [Tokyo_Keiso] }, /* TOKYO KEISO */								\
	  { 131, [SMC] }, /* SMC */												\
	  { 132, [Status_Instruments] }, /* Status Instruments */				\
	  { 133, [Huakong] }, /* Huakong */										\
	  { 134, [Duon_System] }, /* Duon System */								\
	  { 135, [Vortek_Instruments_LLC] }, /* Vortek Instruments, LLC */		\
	  { 136, [AG_Crosby] }, /* AG Crosby */									\
	  { 137, [Action_Instruments] }, /* Action Instruments */				\
    { 138, [Keystone_Controls] }, /* Keystone Controls */					\
    { 139, [Thermo_Electric_Company] }, /* Thermo Electric Co. */			\
    { 140, [ISE_Magtech] }, /* ISE-Magtech */								\
    { 156, "Turck" },														\
	  { 160, "FINT" },														\
    { 161, "BERTHOLD TECHNOLOGIES" },										\
    { 169, "Invensys" },													\
    { 171, "TycoValveControls" },											\
    { 212, "SIC" },                                   \
    { 250, [not_used] },													\
    { 251, [none] },														\
    { 252, [unknown] },													\
	{ 0x142, "Testo AG" },													\
    { 253, [special] }													\


/**************************************************/
/******************* Configuration ****************/
/**************************************************/

// Parameter:	PHYS_ADDITIONAL_PARAMETER
// Parameter:	PHYS_MULTIVARIABLE_DEVICE
// Parameter:	PHYS_ADDITIONAL_GROUP_SPECIALIST
// Parameter:	PHYS_ADDITIONAL_GROUP_MAINTENANCE
// Parameter:	PHYS_IDENT_SPECIFIC
// Parameter:	MANUFACTURER_SPECIFIC_phys_factory_reset

// To disable optional parameters use the following macros
// NO_phys_hw_write_protection
// NO_phys_local_operation_enable
// NO_phys_diagnosis_extension
// NO_phys_diagnosis_extension_mask

// To disable/enable optional enumeration of phys_ident_number define the following macros
//#define NO_phys_ident_number_MANUFACURER
// OPT_PHYS_IDENT_NUMBER_MANUFACTURER_2_0
// OPT_PHYS_IDENT_NUMBER_MULTIVARIABLE


#ifndef DEVICE_TYPE
#define DEVICE_TYPE " "
#endif


#ifndef PHYSICAL_BLOCK_PARENT_CLASS
#define PHYSICAL_BLOCK_PARENT_CLASS		1,	[phys_blk_parent_class_TRANSMITTER]
#endif

#define DEFAULT_MANUFACTURER_ID	0x142
#ifndef DEFAULT_MANUFACTURER_ID
#define DEFAULT_MANUFACTURER_ID	252
#endif


#ifndef DEFAULT_phys_ident_number
#define DEFAULT_phys_ident_number	1
#endif

// phys_device_certification wird im Testo Gert nicht untersttzt
//#ifndef DEFAULT_VALUE_phys_device_certification
//#define DEFAULT_VALUE_phys_device_certification "?"
//#endif

#ifndef DEFAULT_VALUE_phys_device_id
#define DEFAULT_VALUE_phys_device_id "Testo 6680"
#endif

#ifndef DEFAULT_VALUE_phys_software_rev
#define DEFAULT_VALUE_phys_software_rev	"?"
#endif


#ifndef PHYS_FACTORY_RESET_ADDRESS
#define PHYS_FACTORY_RESET_ADDRESS	2712 // Ardess-Reset auf 126, optional und nicht im Testo T6680t unterstuetzt
#endif

#ifndef PHYS_FACTORY_RESET_CMD
#define PHYS_FACTORY_RESET_CMD	2506 // Warmstart, optional und nicht im Testo T6680t unterstuetzt
#endif


/**************************************************/
/*************** Windows and dialogs **************/
/**************************************************/

MENU Page_diagnosis_phys_block
{
	LABEL		[blk_block_object_PHYSICAL];
	ITEMS
	{
		phys_blk_object,
		phys_blk_parent_class,
		phys_blk_class,
		phys_blk_dd_reference,
		phys_blk_dd_rev,
		phys_blk_profile,
		phys_blk_profile_rev,
		phys_st_rev,
		phys_actual_mode
	}
}



// --- Reset dialogs

MENU OnlineDialog_reset
{
	LABEL		[master_reset];
	HELP		[master_reset_help];
	ITEMS
	{
		Page_reset
	}
}



MENU Page_reset
{
	LABEL		[master_reset];
	HELP		[master_reset_help];
	ITEMS
	{
		phys_diagnosis,
		SEPARATOR,
		method_phys_factory_reset_params /* ,*/
		/* method_phys_factory_reset_warm, im Testogert nicht untersttzt */
		/* method_phys_factory_reset_address im Testogert nicht untersttzt */
#ifdef MANUFACTURER_SPECIFIC_phys_factory_reset
		,method_phys_factory_reset_device_specific
#endif
	}
}



// --- Parameter table --------------------------------------------------------

MENU Tab_s_ident
{
	LABEL		[menu_ident];

	ITEMS
	{
		Tab_s_ident_opunit,
		Tab_s_ident_device

#ifdef PHYS_ADDITIONAL_GROUP_SPECIALIST
		,
		PHYS_ADDITIONAL_GROUP_SPECIALIST
#endif
	}
}

/* #ifdef _V602_
#define IUM_IDENT_OPUNIT \
        TAG_FUNCTION, \
        TAG_LOCATION, \
        DESCRIPTOR, \
        INSTALLATION_DATE, \
        SIGNATURE, \
#endif */

MENU Tab_s_ident_opunit
{
	LABEL		[menu_ident_opunit];
	ITEMS
	{
		phys_tag_desc
#ifdef IUM_IDENT_OPUNIT
    ,
    IUM_IDENT_OPUNIT
#endif

	}
}

MENU Tab_m_ident
{
	LABEL		[menu_ident];
	ITEMS
	{
		Tab_m_ident_opunit,
		Tab_m_ident_device
#ifdef PHYS_ADDITIONAL_GROUP_MAINTENANCE
		,
		PHYS_ADDITIONAL_GROUP_MAINTENANCE
#endif
	}
}

MENU Tab_m_ident_opunit
{
	LABEL		[menu_ident_opunit];
	ITEMS
	{
		phys_tag_desc		(READ_ONLY)
	}
}

/* Not supported in the T6680:
		phys_descriptor,
		phys_message
*/

/* Not supported in the T6680:
MENU Tab_s_certificates
{
	LABEL		[menu_certificates];
	ITEMS
	{
		phys_device_certification	(READ_ONLY)
	}
}
*/


// --- Physical Block (Profile 3) ---------------------------------------------

#define PHYS_LOAD_TO_PC				\
		phys_st_rev,				\
		phys_tag_desc,				\
		phys_device_man_id,			\
		phys_device_id				\
		phys_device_ser_num,		\
		phys_software_rev,			\
		phys_hardware_rev,			\
		phys_blk_profile_rev,		\
		phys_ident_number

/* Not supported in the T6680:
		phys_device_certification,	\
		phys_install_date,			\
    phys_descriptor,			\
    phys_message				\
*/

#define PHYS_LOAD_TO_DEVICE			\
		phys_tag_desc, \
		phys_ident_number

/* Not supported in the T6680:
		phys_install_date,			\
    phys_descriptor,			\
    phys_message				\
*/

// --- Windows and dialogs ---------------------------------------------------------------

MENU Page_diagnosis_general
{
	LABEL		[menu_dialog_general];
	ITEMS
	{
		phys_tag_desc			(READ_ONLY),
		phys_device_man_id,
		phys_device_id,
		phys_device_ser_num,
		phys_software_rev,
		phys_hardware_rev,
		phys_install_date		(READ_ONLY),

#ifndef NO_phys_write_locking
		phys_write_locking	(READ_ONLY),
#endif

		phys_diagnosis
	}
}


// --- Parameter table --------------------------------------------------------

#ifdef _V602_
#define PHYS_ADDITIONAL_PARAMETER \
        ORDER_ID, \
		    IM_VERSION, \
		    REV_COUNTER
#endif

/* I&M-Vars Not supported in the T66680, because allready given in the PB-Block:
        PROFILE_ID_HIBYTE, \
        MANUFACTURER_ID, \
        SERIAL_NUMBER, \
		    HARDWARE_REVISION, \
        SOFTWARE_REVISION \
*/

MENU Tab_s_ident_device
{
	LABEL		[menu_ident_device];
	ITEMS
	{
		phys_device_man_id,
		phys_device_id,
		phys_device_ser_num,
		phys_software_rev,
		phys_hardware_rev,
		phys_blk_profile_rev,
		phys_st_rev,
		phys_ident_number
#ifdef PHYS_ADDITIONAL_PARAMETER
		,
		PHYS_ADDITIONAL_PARAMETER
#endif
	}
}


MENU Tab_m_ident_device
{
	LABEL		[menu_ident_device];
	ITEMS
	{
		phys_device_man_id,
		phys_device_id,
		phys_device_ser_num,
		phys_software_rev,
		phys_hardware_rev,
		phys_blk_profile_rev,
		phys_st_rev,
		phys_ident_number	(READ_ONLY)
#ifdef PHYS_ADDITIONAL_PARAMETER
		,
		PHYS_ADDITIONAL_PARAMETER
#endif
	}
}


#ifndef NO_phys_write_locking
MENU OnlineDialog_write_locking
{
	LABEL		[phys_write_locking];
	HELP		[phys_write_locking_help];
	ITEMS
	{
		phys_write_locking,

#ifndef NO_phys_hw_write_protection
		phys_hw_write_protection,
#endif

		SEPARATOR,
		method_set
	}
}

#endif


/**************************************************/
/************** PB Block Parameter ****************/
/**************************************************/

BLOCK physical_block
{
	TYPE	PHYSICAL;
	NUMBER	1;
}

VARIABLE phys_blk_reserve
{
	LABEL		[blk_reserved];
	HELP		[blk_reserved_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE phys_blk_object
{
	LABEL		[blk_block_object];
	HELP		[blk_block_object_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		{	1,	[blk_block_object_PHYSICAL]	}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_parent_class
{
	LABEL		[blk_parent_class];
	HELP		[phys_blk_parent_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{ PHYSICAL_BLOCK_PARENT_CLASS }
	}
	HANDLING	READ;
}

VARIABLE phys_blk_class
{
	LABEL		[blk_class];
	HELP		[phys_blk_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		DEFAULT_VALUE	250;
		{	250,	[not_used]		}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_dd_reference
{
	LABEL		[blk_dd_reference];
	HELP		[blk_dd_reference_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (4);
	HANDLING	READ;
}

VARIABLE phys_blk_dd_rev
{
	LABEL		[blk_dd_rev];
	HELP		[blk_dd_rev_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(2);
	HANDLING	READ;
}

VARIABLE phys_blk_profile
{
	LABEL		[blk_profile];
	HELP		[blk_profile_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
#ifdef DEFAULT_VALUE_phys_blk_profile
		DEFAULT_VALUE_phys_blk_profile
#endif
		{ 0x4001,	[blk_profile_PA_COMPACT_A]	},
		{ 0x4002,	[blk_profile_PA_COMPACT_B]	},
		{ 0x4081,	[blk_profile_PA_SIMPLE_A]	},
		{ 0x4082,	[blk_profile_PA_SIMPLE_B]	}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_profile_rev
{
	LABEL		[blk_profile_rev];
	HELP		[blk_profile_rev_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
#ifdef CHECK_PROFILE_REV
		DEFAULT_VALUE	CHECK_PROFILE_REV ;
#else
		DEFAULT_VALUE	0x0301;
#endif
		{	0x025A,	"2.90"	},
		{	0x025B,	"2.91"	},
		{	0x025C,	"2.92"	},
		{	0x025D,	"2.93"	},
		{	0x025E,	"2.94"	},
		{	0x025F,	"2.95"	},
		{	0x0260,	"2.96"	},
		{	0x0261,	"2.97"	},
		{	0x0262,	"2.98"	},
		{	0x0263,	"2.99"	},
		{	0x0300,	"3.0"	},
		{	0x0301,	"3.01"	}

	}
	HANDLING	READ;
	PURPOSE		"Device.Type.Ident.ProfileRevision";
}

VARIABLE phys_blk_execution_time
{
	LABEL		[blk_execution_time];
	HELP		[blk_execution_time_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(1);
	HANDLING	READ;
}

VARIABLE phys_blk_num_parameters
{
	LABEL		[blk_num_parameters];
	HELP		[blk_num_parameters_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE phys_blk_index_view_1
{
	LABEL		[blk_index_view_1];
	HELP		[blk_index_view_1_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE phys_blk_num_view_lists
{
	LABEL		[blk_num_view_lists];
	HELP		[blk_num_view_lists_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE phys_st_rev
{
	LABEL		[st_rev];
	HELP		[st_rev_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ;
}

VARIABLE phys_tag_desc
{
	/* ST_REV */
	LABEL		[tag_desc];
	HELP		[tag_desc_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32);
	HANDLING	READ & WRITE;
	PURPOSE		"Device.App.Ident.TAG";
}

VARIABLE phys_strategy
{
	/* ST_REV */
	LABEL		[strategy];
	HELP		[strategy_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_alert_key
{
	/* ST_REV */
	LABEL		[alert_key];
	HELP		[alert_key_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_target_mode
{
	/* ST_REV */
	LABEL		[target_mode];
	HELP		[target_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0x08;
		{	0x02,	[mode_RCAS]				},
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x20,	[mode_LO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_actual_mode
{
	LABEL		[actual_mode];
	HELP		[actual_mode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE 0x08 ;
		{	0x02,	[mode_RCAS]				},
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x20,	[mode_LO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

VARIABLE phys_permitted_mode
{
	LABEL		[permitted_mode];
	HELP		[permitted_mode_help];
	CLASS		CONTAINED;
	TYPE		BIT_ENUMERATED (1)
	{
		DEFAULT_VALUE	0x08;
		{	0x02,	[mode_RCAS]				},
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x20,	[mode_LO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

VARIABLE phys_normal_mode
{
	LABEL		[normal_mode];
	HELP		[normal_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0x08;

		{	0x02,	[mode_RCAS]				},
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x20,	[mode_LO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}

	}
	HANDLING	READ;
}

VARIABLE phys_current_state_alarm_sum
{
	LABEL		[current_state_alarm_sum];
	HELP		[current_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0000;
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

VARIABLE phys_unacknowledged_state_alarm_sum
{
	LABEL		[unacknowledged_state_alarm_sum];
	HELP		[unacknowledged_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0000;
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

VARIABLE phys_unreported_state_alarm_sum
{
	LABEL		[unreported_state_alarm_sum];
	HELP		[unreported_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0000;
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

VARIABLE phys_disabled_state_alarm_sum
{
	LABEL		[disabled_state_alarm_sum];
	HELP		[disabled_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0000;
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

VARIABLE phys_software_rev
{
	LABEL		[phys_software_revision];
	HELP		[phys_software_revision_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16)
	{
		DEFAULT_VALUE	"1";
	}
	HANDLING	READ;
	PURPOSE		"Device.Type.Ident.SwRevision";
}

VARIABLE phys_hardware_rev
{
	LABEL		[phys_hardware_revision];
	HELP		[phys_hardware_revision_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16)
	{
		DEFAULT_VALUE	"1";
	}
	HANDLING	READ;
	PURPOSE		"Device.Type.Ident.HwRevision";
}

VARIABLE phys_device_man_id
{
	LABEL		[phys_device_man_id];
	HELP		[phys_device_man_id_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	DEFAULT_MANUFACTURER_ID ;
		MANUFACTURER_LIST
	}
	HANDLING	READ;
	PURPOSE		"Device.Type.Ident.Manufacturer";
}

VARIABLE phys_device_id
{
	LABEL		[phys_device_type];
	HELP		[phys_device_type_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16)
	{
		DEFAULT_VALUE	DEVICE_TYPE;
	}
	HANDLING	READ;
	PURPOSE		"Device.Type.Ident.Type";
}

VARIABLE phys_device_ser_num
{
	LABEL		[phys_device_ser_num];
	HELP		[phys_device_ser_num_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16);
	HANDLING	READ;
	PURPOSE		"Device.Ident.SerialNumber";
}

#define DIA_HW_ELECTR			0x01000000		/* 0x00000001 */
#define DIA_HW_MECH				0x02000000		/* 0x00000002 */
#define DIA_TEMP_MOTOR			0x04000000		/* 0x00000004 */
#define DIA_TEMP_ELECTR			0x08000000		/* 0x00000008 */
#define DIA_MEM_CHKSUM			0x10000000		/* 0x00000010 */
#define DIA_MEASUREMENT			0x20000000		/* 0x00000020 */
#define DIA_NOT_INIT				0x40000000		/* 0x00000040 */
#define DIA_INIT_ERR				0x80000000		/* 0x00000080 */
#define DIA_ZERO_ERR				0x00010000		/* 0x00000100 */
#define DIA_SUPPLY				0x00020000		/* 0x00000200 */
#define DIA_CONF_INVAL			0x00040000		/* 0x00000400 */
#define DIA_WARMSTART			0x00080000		/* 0x00000800 */
#define DIA_COLDSTART			0x00100000		/* 0x00001000 */
#define DIA_MAINTENANCE			0x00200000		/* 0x00002000 */
#define DIA_CHARACT				0x00400000		/* 0x00004000 */
#define DIA_IDENT_VIOL			0x00800000		/* 0x00008000 */
#define EXTENSION_AVAILABLE			0x00000080		/* 0x80000000 */

VARIABLE phys_diagnosis
{
	LABEL		[phys_diagnosis];
	HELP		[phys_diagnosis_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (4)
	{
		DEFAULT_VALUE    0x00000000;
		{	0,				[dia_OK],					[dia_OK_help]					},
//		{	DIA_HW_ELECTR,		[dia_HW_ELECTR],			[dia_HW_ELECTR_help]			},
//		{	DIA_HW_MECH,		[dia_HW_MECH],				[dia_HW_MECH_help]				},
//		{	DIA_TEMP_MOTOR,		[dia_TEMP_MOTOR],			[dia_TEMP_MOTOR_help]			},
//		{	DIA_TEMP_ELECTR,		[dia_TEMP_ELECTR],			[dia_TEMP_ELECTR_help]			},
//		{	DIA_MEM_CHKSUM,		[dia_MEM_CHKSUM],			[dia_MEM_CHKSUM_help]			},
//		{	DIA_MEASUREMENT,		[dia_MEASUREMENT],			[dia_MEASUREMENT_help]			},
//		{	DIA_NOT_INIT,			[dia_NOT_INIT],				[dia_NOT_INIT_help]				},
//		{	DIA_INIT_ERR,			[dia_INIT_ERR],				[dia_INIT_ERR_help]				},
//		{	DIA_ZERO_ERR,			[dia_ZERO_ERR],				[dia_ZERO_ERR_help]				},
//		{	DIA_SUPPLY,			[dia_SUPPLY],				[dia_SUPPLY_help]				},
//		{	DIA_CONF_INVAL,		[dia_CONF_INVAL],			[dia_CONF_INVAL_help]			},
//		{	DIA_WARMSTART,		[dia_WARMSTART],			[dia_WARMSTART_help]			},
		{	DIA_COLDSTART,		[dia_COLDSTART],			[dia_COLDSTART_help]			},
//		{	DIA_MAINTENANCE,		[dia_MAINTENANCE],			[dia_MAINTENANCE_help]			},
//		{	DIA_CHARACT,			[dia_CHARACT],				[dia_CHARACT_help]				},
//		{	DIA_IDENT_VIOL,		[dia_IDENT_VIOL],			[dia_IDENT_VIOL_help]			}
		{	EXTENSION_AVAILABLE,	[dia_EXTENSION_AVAILABLE],	[dia_EXTENSION_AVAILABLE_help]	}
	}
	HANDLING	READ;
#ifdef _V510_
	STYLE "MULTILINE 16 7" ;
#endif
}

VARIABLE phys_diagnosis_mask
{
	LABEL		[phys_diagnosis_mask];
	HELP		[phys_diagnosis_mask_help];
	CLASS		CONTAINED;
	TYPE		BIT_ENUMERATED (4)
	{
#ifdef DEFAULT_VALUE_phys_diagnosis_mask
	DEFAULT_VALUE DEFAULT_VALUE_phys_diagnosis_mask ;
#endif

//		{	DIA_HW_ELECTR,		[dia_HW_ELECTR],			[dia_HW_ELECTR_help]			},
//		{	DIA_HW_MECH,		[dia_HW_MECH],				[dia_HW_MECH_help]				},
//		{	DIA_TEMP_MOTOR,		[dia_TEMP_MOTOR],			[dia_TEMP_MOTOR_help]			},
//		{	DIA_TEMP_ELECTR,		[dia_TEMP_ELECTR],			[dia_TEMP_ELECTR_help]			},
//		{	DIA_MEM_CHKSUM,		[dia_MEM_CHKSUM],			[dia_MEM_CHKSUM_help]			},
//		{	DIA_MEASUREMENT,		[dia_MEASUREMENT],			[dia_MEASUREMENT_help]			},
//		{	DIA_NOT_INIT,			[dia_NOT_INIT],				[dia_NOT_INIT_help]				},
//		{	DIA_INIT_ERR,			[dia_INIT_ERR],				[dia_INIT_ERR_help]				},
//		{	DIA_ZERO_ERR,			[dia_ZERO_ERR],				[dia_ZERO_ERR_help]				},
//		{	DIA_SUPPLY,			[dia_SUPPLY],				[dia_SUPPLY_help]				},
//		{	DIA_CONF_INVAL,		[dia_CONF_INVAL],			[dia_CONF_INVAL_help]			},
//		{	DIA_WARMSTART,		[dia_WARMSTART],			[dia_WARMSTART_help]			},
		{	DIA_COLDSTART,		[dia_COLDSTART],			[dia_COLDSTART_help]			},
//		{	DIA_MAINTENANCE,		[dia_MAINTENANCE],			[dia_MAINTENANCE_help]			},
//		{	DIA_CHARACT,			[dia_CHARACT],				[dia_CHARACT_help]				},
//		{	DIA_IDENT_VIOL,		[dia_IDENT_VIOL],			[dia_IDENT_VIOL_help]			}
		{	EXTENSION_AVAILABLE,	[dia_EXTENSION_AVAILABLE],	[dia_EXTENSION_AVAILABLE_help]	}
	}
	HANDLING	READ;
}

VARIABLE phys_diagnosis_extension_byte0
{
	LABEL		[phys_diagnosis_extension]+" 1";
	CLASS		CONTAINED & DYNAMIC ;
	TYPE		ENUMERATED (1)
	{
  	{  000, [dia_ext_ok] },
		{  001, [dia_ext_muf] },
		{  002, [dia_ext_probe] }
	}
	HANDLING	READ;
}

VARIABLE phys_diagnosis_extension_byte1
{
	LABEL		[phys_diagnosis_extension]+" 2";
	CLASS		CONTAINED & DYNAMIC ;
	TYPE		ENUMERATED (1)
	{
  	{  000, [dia_ext_ok] },
		{  001, [dia_ext_information] },
		{  002, [dia_ext_warning] },
		{  003, [dia_ext_error] }
	}
	HANDLING	READ;
}

VARIABLE phys_diagnosis_extension_byte2
{
	LABEL		[phys_diagnosis_extension]+" 3";
	CLASS		CONTAINED & DYNAMIC ;
	TYPE		ENUMERATED (1)
	{
		{  000, [dia_ext_ok] },
  	{  001, [dia_ext_measure] },
		{  002, [dia_ext_adjust] },
		{  003, [dia_ext_service] },
		{  004, [dia_ext_configuration] },
		{  005, [dia_ext_communication] },
		{  006, [dia_ext_system] },
		{  007, [dia_ext_environment] }
	}
	HANDLING	READ;
}

VARIABLE phys_diagnosis_extension_byte3
{
	LABEL		[phys_diagnosis_extension]+" 4";
	CLASS		CONTAINED & DYNAMIC ;
	TYPE		ENUMERATED (1)
	{
  	{  0x00, [dia_ext_ok] },
		{  0x05, [dia_ext_Grenzwertverschiebung] },
		{  0x06, [dia_ext_Umskalierung] },
		{  0x07, [dia_ext_Reset_Durchfuehrung] },
		{  0x08, [dia_ext_Fuehler_abgesteckt] },
		{  0x09, [dia_ext_Drift_bei_2_Pkt_Abgleich] },
		{  0x0A, [dia_ext_Zu_hohe_Umgebungstemp] },
		{  0x0B, [dia_ext_Zu_niedrige_Umgebungstemp] },
		{  0x0C, [dia_ext_Versorgungsspannung_zu_niedrig] },
		{  0x0D, [dia_ext_Kommunikation_gestoert] },
		{  0x0E, [dia_ext_Kein_Fuehlersignal] },
		{  0x0F, [dia_ext_Falscher_Fuehler] },
		{  0x10, [dia_ext_WatchDog] },
		{  0x11, [dia_ext_Refresh] },
		{  0x12, [dia_ext_1_Punktabgleich] },
		{  0x13, [dia_ext_2_Punktabgleich_11_3_Proz] },
		{  0x14, [dia_ext_2_Punktabgleich_75_3_Proz] },
		{  0x15, [dia_ext_3_Abgleichpunkt] },
		{  0x16, [dia_ext_Selbstabgleich_aktiv] },
		{  0x17, [dia_ext_Mediumstempetarur_zu_hoch] },
		{  0x18, [dia_ext_Betauungsstart] },
		{  0x19, [dia_ext_Werte_unter_0_Proz_rF] },
		{  0x1A, [dia_ext_Warnung_Deckelelektrode] },
		{  0x1B, [dia_ext_Feuchtesensor_Kurzschluss] },
		{  0x1C, [dia_ext_Feuchtesensor_Bruch] },
		{  0x1D, [dia_ext_Temp_Sensor_Kurzschluss] },
		{  0x1E, [dia_ext_Temp_Sensor_Bruch] },
		{  0x1F, [dia_ext_Selbstabgleichfehler] },
		{  0x20, [dia_ext_Fuehler_Reset] }
	}
	HANDLING	READ;
}




// der 2.Teil der 6 Byte Ext.Diagnose ist null

VARIABLE phys_diagnosis_extension2
{
	LABEL		[phys_diagnosis_extension];
	HELP		[phys_diagnosis_extension_help];
	CLASS		CONTAINED & DYNAMIC ;
	TYPE		ENUMERATED (2)
	{
  	  0
    }
	HANDLING	READ;
}



VARIABLE phys_diagnosis_extension_mask
{
	LABEL		[phys_diagnosis_extension_mask];
	HELP		[phys_diagnosis_extension_mask_help];
	CLASS		CONTAINED;
	TYPE		BIT_ENUMERATED (3);
	HANDLING	READ;
}
VARIABLE phys_diagnosis_extension_mask2
{
	LABEL		[phys_diagnosis_extension_mask];
	HELP		[phys_diagnosis_extension_mask_help];
	CLASS		CONTAINED;
	TYPE		BIT_ENUMERATED (3);
	HANDLING	READ;
}


#ifndef NO_phys_write_locking
VARIABLE phys_write_locking						/* optional */
{
	LABEL		[phys_write_locking];
	HELP		[phys_write_locking_help];
	CLASS		CONTAINED;
#ifdef MANUFACTURER_SPECIFIC_NUM_phys_write_locking
	TYPE		UNSIGNED_INTEGER(2)
#else
	TYPE		ENUMERATED(2)
#endif
	{
		DEFAULT_VALUE	2457;
		{ 2457,		[off]	},
		{ 0,		[on]	}
#ifdef MANUFACTURER_SPECIFIC_phys_write_locking
	,MANUFACTURER_SPECIFIC_phys_write_locking
#endif

	}
	HANDLING	READ & WRITE;
}
#endif

VARIABLE phys_factory_reset						/* optional */
{
	/* ST_REV */
	LABEL		[phys_factory_reset];
	HELP		[phys_factory_reset_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(2)
	{
		DEFAULT_VALUE	0;
		{ 0,		[no_function]			},
		{ 1,		[factory_reset_PARAMS]	},
		{ PHYS_FACTORY_RESET_CMD,			[phys_device_reset_cmd]	},
		{ PHYS_FACTORY_RESET_ADDRESS,		[factory_reset_ADDRESS]	}
#ifdef MANUFACTURER_SPECIFIC_phys_factory_reset
	,MANUFACTURER_SPECIFIC_phys_factory_reset
#endif
	}
	HANDLING	READ & WRITE;
}


#ifndef NO_phys_local_operation_enable
VARIABLE phys_local_operation_enable
{
	LABEL		[trans_act_local_operation];
	HELP		[trans_act_local_operation_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	1;
		{	0,	[disabled]	},
		{	1,	[enabled]	}
	}
	HANDLING	READ & WRITE;
}
#endif

VARIABLE phys_ident_number
{
	LABEL		[phys_ident_number];
	HELP		[phys_ident_number_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE DEFAULT_phys_ident_number ;

		{	0,	[phys_ident_number_PROFILE]		}		// (mand)
#ifndef NO_phys_ident_number_MANUFACURER
		,{	1,	[phys_ident_number_MANUFACURER]	}		// (opt)
#endif
#ifdef OPT_PHYS_IDENT_NUMBER_MANUFACTURER_2_0
		,{	2,	[phys_ident_number_MANUFACTURER_2_0]	}	// (opt)
#endif
#ifdef OPT_PHYS_IDENT_NUMBER_MULTIVARIABLE
		,{	3,	[phys_ident_number_MULTIVARIABLE] }		// (opt)
#endif
#ifdef PHYS_IDENT_SPECIFIC
		,PHYS_IDENT_SPECIFIC
#endif


	}
	HANDLING	READ & WRITE;
}


#ifndef NO_phys_hw_write_protection
VARIABLE phys_hw_write_protection
{
	LABEL		[phys_hw_write_protection];
	HELP		[phys_hw_write_protection_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE 0 ;
		{	1,	[on]	},
		{	0,	[off]	}
	}
	HANDLING	READ;
}
#endif


VARIABLE phys_feature_supported
{
	LABEL   [phys_feature_supported];
	HELP    [phys_feature_supported_help];
	CLASS   CONTAINED;
	STYLE		"MULTILINE 16 5" ;
	TYPE		BIT_ENUMERATED (4)
	{
		DEFAULT_VALUE 0x00000000;
		{	0x01000000,		[condensed_status],			[condensed_status_help]			},
		{	0x02000000,		[expanded_diagnostics],			[expanded_diagnostic_help]			},
		{	0x04000000,		[d_x_b],			[d_x_b_help]			},
		{	0x08000000,		[ms1_ar],			[ms1_ar_help]			},
		{	0x10000000,		[profisafe],			[profisafe_help]			}
  }
	HANDLING READ;
}

VARIABLE phys_feature_enabled
{
	LABEL   [phys_feature_enabled];
	HELP    [phys_feature_enabled_help];
	CLASS   CONTAINED;
	STYLE		"MULTILINE 16 5" ;
	TYPE		BIT_ENUMERATED (4)
	{
		DEFAULT_VALUE 0x00000000;
		{	0x01000000,		[condensed_status_enabled],			[condensed_status_enabled_help]			},
		{	0x02000000,		[expanded_diagnostics_enabled],			[expanded_diagnostic_enabled_help]			},
		{	0x04000000,		[d_x_b_enabled],			[d_x_b_enabled_help]			},
		{	0x08000000,		[ms1_ar_enabled],			[ms1_ar_enabled_help]			},
		{	0x10000000,		[profisafe_enabled],			[profisafe_enabled_help]			}
	}
	HANDLING READ;
}

VARIABLE phys_software_rev_numeric
{
	LABEL		[phys_software_revision];
	CLASS		LOCAL ;
	TYPE		UNSIGNED_INTEGER(2)
	{
		DEFAULT_VALUE 0 ;
	}
	HANDLING	READ;
}

VARIABLE phys_software_rev_000
{
	LABEL		[phys_software_revision];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(1) ;
	HANDLING	READ;
}

phys_software_rev_001 LIKE VARIABLE phys_software_rev_000 {}
phys_software_rev_002 LIKE VARIABLE phys_software_rev_000 {}
phys_software_rev_003 LIKE VARIABLE phys_software_rev_000 {}
phys_software_rev_004 LIKE VARIABLE phys_software_rev_000 {}
phys_software_rev_005 LIKE VARIABLE phys_software_rev_000 {}

VARIABLE phys_software_rev_rest
{
	LABEL		[phys_software_revision];
	CLASS		CONTAINED;
	TYPE		ASCII(10) ;
	HANDLING	READ;
}


/**************************************************/
/************ PB Block Commands *******************/
/**************************************************/

COMMAND read_phys_blk
{
	BLOCK physical_block;
	INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_blk_reserve, phys_blk_object, phys_blk_parent_class, phys_blk_class,
			phys_blk_dd_reference, phys_blk_dd_rev, phys_blk_profile, phys_blk_profile_rev,
			phys_blk_execution_time, phys_blk_num_parameters, phys_blk_index_view_1,
			phys_blk_num_view_lists
		}
	}
}

COMMAND read_phys_st_rev
{
	BLOCK physical_block;
	INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_st_rev
		}
	}
}

COMMAND read_phys_tag_desc
{
	BLOCK physical_block;
	INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_tag_desc
		}
	}
}

COMMAND write_phys_tag_desc
{
	BLOCK physical_block;
	INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_strategy
{
	BLOCK physical_block;
	INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_strategy
		}
	}
}

COMMAND write_phys_strategy
{
	BLOCK physical_block;
	INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_alert_key
{
	BLOCK physical_block;
	INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_alert_key
		}
	}
}

COMMAND write_phys_alert_key
{
	BLOCK physical_block;
	INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_target_mode
{
	BLOCK physical_block;
	INDEX 5;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_target_mode
		}
	}
}

COMMAND write_phys_target_mode
{
	BLOCK physical_block;
	INDEX 5;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
		 	phys_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_mode
{
	BLOCK physical_block;
	INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			 phys_actual_mode, phys_permitted_mode, phys_normal_mode
		}
	}
}

COMMAND read_phys_alarm
{
	BLOCK physical_block;
	INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_current_state_alarm_sum, phys_unacknowledged_state_alarm_sum,
			phys_unreported_state_alarm_sum, phys_disabled_state_alarm_sum
		}
	}
}

COMMAND read_phys_software_rev
{
	BLOCK physical_block;
	INDEX 8;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_software_rev
		}
	}
}



COMMAND read_phys_software_rev_numeric
{
	BLOCK physical_block;
	INDEX 8;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_software_rev_000,
			phys_software_rev_001,
			phys_software_rev_002,
			phys_software_rev_003,
			phys_software_rev_004,
			phys_software_rev_005,
			phys_software_rev_rest
		}
	}
}



COMMAND read_phys_hardware_rev
{
	BLOCK physical_block;
	INDEX 9;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_hardware_rev
		}
	}
}

COMMAND read_phys_device_man_id
{
	BLOCK physical_block;
	INDEX 10;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_man_id
		}
	}
}

COMMAND read_phys_device_id
{
	BLOCK physical_block;
	INDEX 11;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_id
		}
	}
}

COMMAND read_phys_device_ser_num
{
	BLOCK physical_block;
	INDEX 12;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_ser_num
		}
	}
}

COMMAND read_phys_diagnosis
{
	BLOCK physical_block;
	INDEX 13;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_diagnosis
		}
	}
}

#ifndef NO_phys_diagnosis_extension
COMMAND read_phys_diagnosis_extension
{
	BLOCK physical_block;
	INDEX 14;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_diagnosis_extension_byte0,
			phys_diagnosis_extension_byte1,
			phys_diagnosis_extension_byte2,
			phys_diagnosis_extension_byte3,
			phys_diagnosis_extension2
		}
	}
}
#endif

COMMAND read_phys_diagnosis_mask
{
	BLOCK physical_block;
	INDEX 15;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_diagnosis_mask,
			phys_diagnosis_mask2
		}
	}
}

#ifndef NO_phys_diagnosis_extension_mask
COMMAND read_phys_diagnosis_extension_mask
{
	BLOCK physical_block;
	INDEX 16;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_diagnosis_extension_mask,
			phys_diagnosis_extension_mask2
		}
	}
}
#endif

/* Not supported in the T66680:
 COMMAND read_phys_device_certification
{
	BLOCK physical_block;
	INDEX 17;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_certification
		}
	}
}
*/

#ifndef NO_phys_write_locking

COMMAND read_phys_write_locking
{
	BLOCK physical_block;
	INDEX 18;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_write_locking
		}
	}
}

COMMAND write_phys_write_locking
{
	BLOCK physical_block;
	INDEX 18;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_write_locking
		}
		REPLY
		{
		}
	}
}
#endif

COMMAND read_phys_factory_reset
{
	BLOCK physical_block;
	INDEX 19;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_factory_reset
		}
	}
}

COMMAND write_phys_factory_reset
{
	BLOCK physical_block;
	INDEX 19;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_factory_reset
		}
		REPLY
		{
		}
	}
}

/* Not supported in the T66680:
COMMAND read_phys_descriptor
{
	BLOCK physical_block;
	INDEX 20;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_descriptor
		}
	}
}

COMMAND write_phys_descriptor
{
	BLOCK physical_block;
	INDEX 20;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_descriptor
		}
		REPLY
		{
		}
	}
}
*/

COMMAND read_phys_message
{
	BLOCK physical_block;
	INDEX 21;
	OPERATION  READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_message
		}
	}
}

COMMAND write_phys_message
{
	BLOCK physical_block;
	INDEX 21;
	OPERATION  WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_message
		}
		REPLY
		{
		}
	}
}

/* Not supported in the T66680:
COMMAND read_phys_install_date
{
	BLOCK physical_block;
	INDEX 22;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_install_date
		}
	}
}

COMMAND write_phys_install_date
{
	BLOCK physical_block;
	INDEX 22;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_install_date
		}
		REPLY
		{
		}
	}
}
*/

#ifndef NO_phys_local_operation_enable
COMMAND read_phys_local_operation_enable
{
	BLOCK physical_block;
	INDEX 23;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_local_operation_enable
		}
	}
}

COMMAND write_phys_local_operation_enable
{
	BLOCK physical_block;
	INDEX 23;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_local_operation_enable
		}
		REPLY
		{
		}
	}
}
#endif


COMMAND read_phys_ident_number
{
	BLOCK physical_block;
	INDEX 24;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_ident_number
		}
	}
}

COMMAND write_phys_ident_number
{
	BLOCK physical_block;
	INDEX 24;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_ident_number
		}
		REPLY
		{
		}
	}
}


#ifndef NO_phys_hw_write_protection
COMMAND read_phys_hw_write_protection
{
	BLOCK physical_block;
	INDEX 25;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_hw_write_protection
		}
	}
}
#endif

COMMAND read_phys_feature
{
	BLOCK physical_block;
	INDEX 26;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_feature_supported,
			phys_feature_enabled
		}
	}
}

/**************************************************/
/********************  Methods  *******************/
/**************************************************/

METHOD method_phys_factory_reset_params
{
	LABEL		[factory_reset_PARAMS];
	DEFINITION
	{
		int status;

		ACKNOWLEDGE([factory_reset_PARAMS]);

		phys_factory_reset = 1; //	[factory_reset_PARAMS]

		status = WriteCommand (write_phys_factory_reset);
	}
}


METHOD method_phys_factory_reset_warm
{
	LABEL		[phys_device_reset_cmd];
	DEFINITION
	{
		int status;
		char sz[512] ;
		int iLen ;

		get_dictionary_string(phys_device_reset_cmd, sz, iLen) ;

#ifdef _V510_
		sz += "\r\n\r\n" ;
		sz += [note_connection_will_be_aborted] ;
#endif

		ACKNOWLEDGE(sz);

		phys_factory_reset = PHYS_FACTORY_RESET_CMD ;

		status = WriteCommand (write_phys_factory_reset);

		if( status == 17456 )
		{
			ACKNOWLEDGE([not_supported]) ;
		}
	}
}


METHOD method_phys_factory_reset_address
{
	LABEL		[factory_reset_ADDRESS];
	DEFINITION
	{
		int status;
		char sz[512] ;
		int iLen ;

		get_dictionary_string(factory_reset_ADDRESS, sz, iLen) ;

#ifdef _V510_
		sz += "\r\n\r\n" ;
		sz += [note_connection_will_be_aborted] ;
#endif

		ACKNOWLEDGE(sz);

		phys_factory_reset = PHYS_FACTORY_RESET_ADDRESS;

		status = WriteCommand (write_phys_factory_reset);

		if( status == 17456 )
		{
			ACKNOWLEDGE([not_supported]) ;
		}
	}
}


METHOD method_phys_factory_reset_device_specific
{
	LABEL		[device_specific_reset];
	DEFINITION
	{
		int status;
		char sz[512] ;
		int iLen ;

		GET_DEV_VAR_VALUE([reset], phys_factory_reset) ;

		status = WriteCommand (write_phys_factory_reset);

		if( status == 17456 )
		{
			ACKNOWLEDGE([not_supported]) ;
		}
	}
}

METHOD GetNumericSoftwareRevision
{
	LABEL "GetNumericSoftwareRevision" ;
	DEFINITION
	{
		int iSoftwareRev ;
		iSoftwareRev = 0 ;
		ReadCommand(read_phys_software_rev_numeric) ;

		if( (phys_software_rev_001 >= 48) && (phys_software_rev_001 < 58) )
			iSoftwareRev = iSoftwareRev * 10 + phys_software_rev_001 - 48 ;

		if( (phys_software_rev_002 >= 48) && (phys_software_rev_002 < 58) )
			iSoftwareRev = iSoftwareRev * 10 + phys_software_rev_002 - 48 ;

		if( (phys_software_rev_003 >= 48) && (phys_software_rev_003 < 58) )
			iSoftwareRev = iSoftwareRev * 10 + phys_software_rev_003 - 48 ;

		if( (phys_software_rev_004 >= 48) && (phys_software_rev_004 < 58) )
			iSoftwareRev = iSoftwareRev * 10 + phys_software_rev_004 - 48 ;

		if( (phys_software_rev_005 >= 48) && (phys_software_rev_005 < 58) )
			iSoftwareRev = iSoftwareRev * 10 + phys_software_rev_005 - 48 ;

		phys_software_rev_numeric = iSoftwareRev ;
		_TRACE("  phys_software_rev_numeric = " + itoa(iSoftwareRev)) ;
	}
}
