/*===================================================================
 File name:	    T_6680_trans2_hm_0A8A.inc
 Date:      	  Aug. 21. 2006
---------------------------------------------------------------------
 DESCRIPTION:
 Transducer Block 2: Humidity
                                      
 DEVICE:
 T6680 Humidity Device 
---------------------------------------------------------------------
 Revision history:
 REV 0.01 DATE:210806	 TMG/WZ first release

===================================================================*/



/**************************************************/
/******************* Configuration ****************/
/**************************************************/


#ifndef SIPAST_MACROS_300_INC_INCLUDED
#include "SIPAST_Macros_300.inc"
#endif



#ifndef TRANS2_TITLE
#define TRANS2_TITLE	[Feuchte_Transducer]
#endif

// #define _TRANS2_TEMP
#include "T_6680_trans2_0A8A.inc"

/**************************************************/
/******************* Macros ***********************/
/**************************************************/
/*
1000 Kalvin
1001 Grad C
1002 F
1003 Rankine
1101 g/m3
1136 hPa
1146 inch H2O
1342 %
1423ppm
32768 g/kg
32769 gr/lb
32770 J/g
32771 BTU/lb
32772 gr/ft3
*/
#define UNIT_LIST_TESTO\
		{ 1000,	  [unit_1000] },\
		{ 1001,	  [unit_1001] },\
		{ 1002,	  [unit_1002] },\
		{ 1003,	  [unit_1003] },\
		{ 1101,	  [unit_1101] },\
		{ 1136,	  [unit_1136] },\
		{ 1146,	  [unit_1146] },\
		{ 1342,	  [unit_1342] },\
		{ 1423,	  [unit_1423] },\
		{ 32768,	[unit_32768] },\
		{ 32769,  [unit_32769] },\
		{ 32770,	[unit_32770] },\
		{ 32771,  [unit_32771] },\
		{ 32772,  [unit_32772] }
 
#define TB_UNITS\
	    {1001,[unit_1001]},\
			{1000,[unit_1000]},\
			{1002,[unit_1002]},\
			{1003,[unit_1003]},\
			{1342,[unit_1342]},\
			{1101,[unit_1101]},\
			{32768,[unit_32768]},\
			{32769,[unit_32769]},\
			{32770,[unit_32770]},\
			{32771,[unit_32771]},\
			{32772,[unit_32772]},\
			{1136,[unit_1136]},\
			{1146,[unit_1146]},\
			{1423,[unit_1423]}


#define TRANS2_LOAD_TO_PC								\
      trans2_st_rev,								    \
      trans2_hm_primary_value_unit,        \
		  trans2_hm_pv_unit_text,           \
		  trans2_hm_primary_value_type,     \
		  trans2_hm_secondary_value_unit_1,      \
		  trans2_hm_sv_1_unit_text,         \
		  trans2_hm_secondary_value_type_1, \
		  trans2_hm_heater_on_time,         \
      trans2_hm_heater_off_time,        \
      trans2_hm_operating_state,        \
      trans2_hm_alarm_lim_relay_1,       \
      trans2_hm_alarm_lim_relay_2,       \
      trans2_hm_alarm_lim_relay_3,       \
      trans2_hm_alarm_lim_relay_4,       \
      trans2_hm_muf_type,               \
      trans2_hm_connected_state,        \
      trans2_hm_num_relay_connected,    \
      trans2_hm_relay_status

#define TRANS2_LOAD_TO_DEVICE					  \
      trans2_hm_primary_value_unit,     \
		  trans2_hm_primary_value_type,     \
		  trans2_hm_secondary_value_unit_1, \
		  trans2_hm_sv_1_unit_text,         \
		  trans2_hm_secondary_value_type_1 




/**************************************************/
/*************** Windows and dialogs **************/
/**************************************************/

MENU Page_display_trans2
{
	LABEL		[menu_dialog_display_measure];
	ITEMS
	{
		trans2_hm_primary_value_unit		(HIDDEN),
		BarVal_pv_display_trans2,
		Group_display_primary_trans2,
		Group_display_secondary_trans2
	}
}

MENU BarVal_pv_display_trans2
{
	LABEL		[trans_value];
	ITEMS
	{
		trans2_hm_primary_value,
		func2_AI_pv_lower_range_value (READ_ONLY),
		func2_AI_pv_upper_range_value (READ_ONLY)
	}
}

MENU Group_display_primary_trans2
{
	LABEL		[trans_value];
	ITEMS
	{
		trans2_hm_primary_value,
		SEPARATOR,
		trans2_primary_value_status_quality,
		trans2_primary_value_status_limit
	}
}

MENU Group_display_secondary_trans2
{
	ITEMS
	{
		trans2_hm_secondary_value_1
	}
}


#ifndef NO_trans2_minmax_sensor_value

#define TRANS2_MEASINDICATOR_AVAILABLE

MENU group_trans2_measindicator
{
	LABEL		TRANS2_TITLE ;
	ITEMS
	{
#ifndef NO_trans2_min_sensor_value_1
		trans2_min_sensor_value_1 (READ_ONLY),
#endif

#ifndef NO_trans2_max_sensor_value_1
		trans2_max_sensor_value_1 (READ_ONLY),
#endif

#ifndef NO_trans2_min_sensor_value_2
		trans2_min_sensor_value_2 (READ_ONLY),
#endif

#ifndef NO_trans2_max_sensor_value_2
		trans2_max_sensor_value_2 (READ_ONLY)
#endif
	}
}

#endif



// --- Parameter table --------------------------------------------------------

MENU Tab_s_trans2
{
	LABEL		TRANS2_TITLE ;
	ITEMS
	{
		  trans2_st_rev,
		  trans2_hm_primary_value_type (READ_ONLY),
      trans2_hm_primary_value_unit (READ_ONLY),
		  trans2_hm_secondary_value_type_1 (READ_ONLY),
		  trans2_hm_secondary_value_unit_1 (READ_ONLY)
	}
}


MENU Tab_m_trans2
{
	LABEL		TRANS2_TITLE ;
	ITEMS
	{
		  trans2_hm_primary_value_type (READ_ONLY),
      trans2_hm_primary_value_unit (READ_ONLY),
		  trans2_hm_secondary_value_type_1 (READ_ONLY),
		  trans2_hm_secondary_value_unit_1 (READ_ONLY)
	}
}

MENU Tab_s_trans2_measrange
{
	LABEL		[menu_input_measrange];
	ITEMS
	{
		trans2_hm_lower_sensor_limit (READ_ONLY),
		trans2_hm_upper_sensor_limit (READ_ONLY)
	}
}









// --- Parameter --------------------------------------------------------------

VARIABLE trans2_hm_primary_value
{
	LABEL		[trans_value];
//	HELP		[trans_hm_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DISPLAY_FORMAT	"7.3f";
	}
	HANDLING	READ;
}

VARIABLE trans2_hm_primary_value_status_quality
{
	LABEL		[status_quality];
	HELP		[value_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	0;
		STATUS_OUTPUT_NO_RCAS
	}
	HANDLING	READ;
}

trans2_hm_primary_value_status_limit			LIKE VARIABLE	trans2_hm_primary_value_status_quality
{
	REDEFINE LABEL		[status_limit];
	REDEFINE TYPE		ENUMERATED (2)
	{
		STATUS_OUTPUT_LIMIT
	}
}

VARIABLE trans2_hm_primary_value_unit
{
	LABEL		[digital_units];
	HELP		[digital_units_help];	/* ??? Text */
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
	  1342
	}
	POST_EDIT_ACTIONS
	{
		method_set_trans2_input_range
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans2_hm_secondary_value_1
{
	LABEL		[trans_value]+" 2";
//	HELP		[trans_secondary_value_1_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DISPLAY_FORMAT	"7.3f";
	}
	HANDLING	READ;
}

VARIABLE trans2_hm_secondary_value_1_status_quality
{
	LABEL		[status_quality];
	HELP		[value_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	0;
		STATUS_OUTPUT_NO_RCAS
	}
	HANDLING	READ;
}

trans2_hm_secondary_value_1_status_limit		LIKE VARIABLE	trans2_hm_secondary_value_1_status_quality
{
	REDEFINE LABEL		[status_limit];
	REDEFINE TYPE		ENUMERATED (2)
	{
		STATUS_OUTPUT_LIMIT
	}
}


VARIABLE trans2_hm_upper_sensor_limit
{
	LABEL		[trans_sensor_upper_limit];
	HELP		[trans_sensor_upper_limit_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE 100 ;
	}
	HANDLING	READ;
}

VARIABLE trans2_hm_lower_sensor_limit
{
	LABEL		[trans_sensor_lower_limit];
	HELP		[trans_sensor_lower_limit_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE 0 ;
	}
	HANDLING	READ;
}

//Testo-specific

/* Variables */


VARIABLE trans2_hm_relay_status
{
	LABEL		[relay_status];
//	HELP		[relay_status_help];
	CLASS		CONTAINED;
	TYPE		ASCII (1);
	HANDLING	READ;
}

VARIABLE trans2_hm_num_relay_connected
{
	LABEL		[num_relay_connected];
//	HELP		[num_relay_connected_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE trans2_hm_connected_state
{
	LABEL		[connected_state];
//	HELP		[connected_state_help];
	CLASS		CONTAINED;
	TYPE		ASCII (35)
	{
		DEFAULT_VALUE 0x01;
    {	0x00	,	"nothing connected"	}	,
    {	0x01	,	"PROFIBUS"	}	,
    {	0x02	,	"Ethernet"	}	,
    {	0x03	,	"PROFIBUS+Ethernet"	}	,
    {	0x04	,	"Service"	}	,
    {	0x05	,	"PROFIBUS+Service"	}	,
    {	0x06	,	"Ethernet+Service"	}	,
    {	0x07	,	"PROFIBUS+Ethernet+Service"	}	,
    {	0x08	,	"Display"	}	,
    {	0x09	,	"PROFIBUS+Display"	}	,
    {	0x0A	,	"Ethernet+Display"	}	,
    {	0x0B	,	"PROFIBUS+Ethernet+Display"	}	,
    {	0x0C	,	"Service+Display"	}	,
    {	0x0D	,	"PROFIBUS+Service+Display"	}	,
    {	0x0E	,	"Ethernet+Service+Display"	}	,
    {	0x0F	,	"PROFIBUS+Ethernet+Service+Display"	}
	}
	HANDLING	READ;
}

VARIABLE trans2_hm_muf_type
{
	LABEL		[muf_type];
//	HELP		[muf_type_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	0x00;
		{		0x00	,		[_4_20mA_2_wire_2AO]		}	,
    {		0x01	,		[_4_20mA_2_wire_3AO]		}	,
    {		0x02	,		[_0_20mA_4_wire_2AO]		}	,
    {		0x03	,		[_0_20mA_4_wire_3AO]		}	,
    {		0x04	,		[_0_1V_4_wire_2AO]		}	,
    {		0x05	,		[_0_1V_4_wire_3AO]		}	,
    {		0x06	,		[_0_5V_4_wire_2AO]		}	,
    {		0x07	,		[_0_5V_4_wire_3AO]		}	,
    {		0x08	,		[_0_10V_4_wire_2AO]		}	,
    {		0x09	,		[_0_10V_4_wire_3AO]		}	,
    {		0x0A	,		[_4_20mA_2_wire_Ex]		}
  }
	HANDLING	READ;
}

VARIABLE trans2_hm_alarm_lim_relay_4
{
	LABEL		[alarm_lim_relay_4];
//	HELP		[alarm_lim_relay_4_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
	  0
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans2_hm_alarm_lim_relay_3
{
	LABEL		[alarm_lim_relay_3];
//	HELP		[alarm_lim_relay_3_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)	
	{
	  0
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans2_hm_alarm_lim_relay_2
{
	LABEL		[alarm_lim_relay_2];
//	HELP		[alarm_lim_relay_2_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
	  0
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans2_hm_alarm_lim_relay_1
{
	LABEL		[alarm_lim_relay_1];
//	HELP		[alarm_lim_relay_1_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
    {
	  0
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans2_hm_operating_state
{
	LABEL		[operating_state];
//	HELP		[operating_state_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (4);
	HANDLING	READ;
}

VARIABLE trans2_hm_heater_off_time
{
	LABEL		[heater_off_time];
//	HELP		[heater_off_time_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE 15;
		MAX_VALUE 65001;
		MIN_VALUE 0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans2_hm_heater_on_time
{
	LABEL		[heater_on_time];
//	HELP		[heater_on_time_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE 15;
		MAX_VALUE 65000;
		MIN_VALUE 0;
	}
	HANDLING	READ & WRITE;
}


VARIABLE trans2_hm_secondary_value_type_1
{
	LABEL		[secondary_value_type_1];
//	HELP		[secondary_value_type_1_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	0;
    { 0, [Relative_Humidity] },
    { 1, [Dew_Point] },
    { 2, [Absolute_Humidity] },
    { 3, [Specific_Humidity] },
    { 4, [Enthalpie] },
    { 5, [Psychrometertemperature] },
    { 6, [Vapour_partial_pressure] },
    { 7, [Water_Content] }
  }
	HANDLING	READ & WRITE;
}

VARIABLE trans2_hm_sv_1_unit_text
{
	LABEL		[sv_1_unit_text];
//	HELP		[sv_1_unit_text_help];
	CLASS		CONTAINED;
	TYPE		ASCII (8);
	HANDLING	READ & WRITE;
}

VARIABLE trans2_hm_secondary_value_unit_1
{
	LABEL		[secondary_value_unit_1];
//	HELP		[secondary_value_unit_1_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE 1342; // %
		TB_UNITS
		}
	HANDLING	READ & WRITE;
}


VARIABLE trans2_hm_primary_value_type
{
	LABEL		[primary_value_type];
//	HELP		[primary_value_type_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	0;
		{ 0, [Relative_Humidity] },
    { 1, [Dew_Point] },
    { 2, [Absolute_Humidity] },
    { 3, [Specific_Humidity] },
    { 4, [Enthalpie] },
    { 5, [Psychrometertemperature] },
    { 6, [Vapour_partial_pressure] },
    { 7, [Water_Content] }
  }
	HANDLING	READ & WRITE;
}

VARIABLE trans2_hm_pv_unit_text
{
	LABEL		[pv_unit_text];
//	HELP		[pv_unit_text_help];
	CLASS		CONTAINED;
	TYPE		ASCII (8);
	HANDLING	READ & WRITE;
}

/**************************************************
************* TB_HM Block Commands **************
**************************************************/

COMMAND read_trans2_primary_value
{
	BLOCK transducer_block_2;
	INDEX 8;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_primary_value,
			trans2_hm_primary_value_status_quality	<0xFC>,
			trans2_hm_primary_value_status_limit	<0x03>
		}
	}
}

COMMAND read_trans2_hm_primary_value_unit
{
	BLOCK transducer_block_2;
	INDEX 9;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_primary_value_unit
		}
	}
}

COMMAND write_trans2_hm_primary_value_unit
{
	BLOCK transducer_block_2;
	INDEX 9;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_hm_primary_value_unit
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_hm_pv_unit_text
{
	BLOCK transducer_block_2;
	INDEX 10;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_pv_unit_text
		}
	}
}

COMMAND write_trans2_hm_primary_value_type
{
	BLOCK transducer_block_2;
	INDEX 11;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_hm_primary_value_type
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_hm_primary_value_type
{
	BLOCK transducer_block_2;
	INDEX 11;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_primary_value_type
		}
	}
}

COMMAND read_trans2_secondary_value_1
{
	BLOCK transducer_block_2;
	INDEX 12;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_secondary_value_1,
			trans2_hm_secondary_value_1_status_quality	<0xFC>,
			trans2_hm_secondary_value_1_status_limit	<0x03>
		}
	}
}




COMMAND read_trans2_hm_secondary_value_unit_1
{
	BLOCK transducer_block_2;
	INDEX 13;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_secondary_value_unit_1
		}
	}
}

COMMAND write_trans2_hm_secondary_value_unit_1
{
	BLOCK transducer_block_2;
	INDEX 13;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_hm_secondary_value_unit_1
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_hm_sv_1_unit_text
{
	BLOCK transducer_block_2;
	INDEX 14;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_sv_1_unit_text
		}
	}
}

COMMAND write_trans2_hm_sv_1_unit_text
{
	BLOCK transducer_block_2;
	INDEX 14;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_hm_sv_1_unit_text
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_hm_secondary_value_type_1
{
	BLOCK transducer_block_2;
	INDEX 15;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_secondary_value_type_1
		}
	}
}

COMMAND write_trans2_hm_secondary_value_type_1
{
	BLOCK transducer_block_2;
	INDEX 15;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_hm_secondary_value_type_1
		}
		REPLY
		{
		}
	}
}



COMMAND read_trans2_hm_heater_on_time
{
	BLOCK transducer_block_2;
	INDEX 20;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_heater_on_time
		}
	}
}

COMMAND write_trans2_hm_heater_on_time
{
	BLOCK transducer_block_2;
	INDEX 20;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_hm_heater_on_time
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_hm_heater_off_time
{
	BLOCK transducer_block_2;
	INDEX 21;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_heater_off_time
		}
	}
}

COMMAND write_trans2_hm_heater_off_time
{
	BLOCK transducer_block_2;
	INDEX 21;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_hm_heater_off_time
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_hm_operating_state
{
	BLOCK transducer_block_2;
	INDEX 22;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_operating_state
		}
	}
}

COMMAND write_trans2_hm_operating_state
{
	BLOCK transducer_block_2;
	INDEX 22;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_hm_operating_state
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_hm_alarm_lim_relay_1
{
	BLOCK transducer_block_2;
	INDEX 23;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_alarm_lim_relay_1
		}
	}
}

COMMAND write_trans2_hm_alarm_lim_relay_1
{
	BLOCK transducer_block_2;
	INDEX 23;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_hm_alarm_lim_relay_1
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_hm_alarm_lim_relay_2
{
	BLOCK transducer_block_2;
	INDEX 24;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_alarm_lim_relay_2
		}
	}
}

COMMAND write_trans2_hm_alarm_lim_relay_2
{
	BLOCK transducer_block_2;
	INDEX 24;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_hm_alarm_lim_relay_2
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_hm_alarm_lim_relay_3
{
	BLOCK transducer_block_2;
	INDEX 25;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_alarm_lim_relay_3
		}
	}
}

COMMAND write_trans2_hm_alarm_lim_relay_3
{
	BLOCK transducer_block_2;
	INDEX 25;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_hm_alarm_lim_relay_3
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_hm_alarm_lim_relay_4
{
	BLOCK transducer_block_2;
	INDEX 26;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_alarm_lim_relay_4
		}
	}
}

COMMAND write_trans2_hm_alarm_lim_relay_4
{
	BLOCK transducer_block_2;
	INDEX 26;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_hm_alarm_lim_relay_4
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_hm_muf_type
{
	BLOCK transducer_block_2;
	INDEX 27;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_muf_type
		}
	}
}

COMMAND read_trans2_hm_connected_state
{
	BLOCK transducer_block_2;
	INDEX 28;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_connected_state
		}
	}
}

COMMAND read_trans2_hm_num_relay_connected
{
	BLOCK transducer_block_2;
	INDEX 29;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_num_relay_connected
		}
	}
}

COMMAND read_trans2_hm_relay_status
{
	BLOCK transducer_block_2;
	INDEX 30;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_relay_status
		}
	}
}

COMMAND read_trans2_hm_probe_status
{
	BLOCK transducer_block_2;
	INDEX 31;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_probe_status
		}
	}
}

COMMAND read_trans2_hm_muf_info
{
	BLOCK transducer_block_2;
	INDEX 32;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_muf_info
		}
	}
}

COMMAND read_trans2_hm_muf_warning
{
	BLOCK transducer_block_2;
	INDEX 33;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_muf_warning
		}
	}
}

COMMAND read_trans2_hm_muf_error
{
	BLOCK transducer_block_2;
	INDEX 34;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_muf_error
		}
	}
}

COMMAND read_trans2_hm_probe_info
{
	BLOCK transducer_block_2;
	INDEX 35;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_probe_info
		}
	}
}

COMMAND read_trans2_hm_probe_warning
{
	BLOCK transducer_block_2;
	INDEX 36;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_probe_warning
		}
	}
}

COMMAND read_trans2_hm_input_fault
{
	BLOCK transducer_block_2;
	INDEX 37;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_hm_input_fault
		}
	}
}


/*******************************************************************************/
/*****	Methods		************************************************************/
/*******************************************************************************/

// --- Unit relations ---------------------------------------------------------

/* Humidity Transducer Block */
UNIT UNIT_LIST_HM_TRANS_2
{
	trans2_hm_primary_value_unit:

	trans2_hm_primary_value,
	trans2_hm_secondary_value_1,
	trans2_hm_upper_sensor_limit,
	trans2_hm_lower_sensor_limit,
}
